#!/usr/bin/python
#-------------------------------------------------------------------------------
# Main
import sys
import System 
import time
import traceback
import MTException as MTE
        
try:
    # Reading the command line arguments
    input_file_type=None
    while len(sys.argv)>1:
        option=sys.argv[1]; del sys.argv[1]
        if option=='-i':
            input_file_name=sys.argv[1]; del sys.argv[1]
        elif option=='-t':
            if sys.argv[1]=='old': 
                input_file_type='old'; del sys.argv[1]
            elif sys.argv[1]=='new':
                input_file_type='new'; del sys.argv[1]
            else :
                print 'unknown type of input file is stated:',sys.argv[1]
                print 'available options are "new" and "old"'
                sys.exit(1)        
        else:
            print 'invalid input parameters:',option            
            sys.exit(1)
    # Checking if all important input parameters are read.
    try: 
        print 'Main input file:',input_file_name
    except NameError:
         print "No input file name provided \n Try rdf.py -i input "; sys.exit(1)
#    try: 
#        print 'Main input file type:',input_file_type
#    except NameError:
#         print "No input file type provided \n Try rdf.py -i input "; sys.exit(1)
    # Here we create "the system" object and read it's molecular description and settings
    system=System.System(input_file_name,input_file_type)
    e0=time.time()
    c0=time.clock()
    system._RDF_pairs_matrix() #Create matrix of pairs for RDFs
    system._ADF_pairs_matrix() #Create matrix of pairs for ADFs
    if len(system.RDFs)>0:    
        system.Calculate(system.RDFs,plot=False,smooth=True,trim=True)
    if len(system.ADFs)>0:    
        system.Calculate(system.ADFs,tolerance=1.0e-6,plot=False,smooth=True,trim=True)
    system.DFs_SaveForMagic()
    system.write_MCMs()
    if len(system.box)>0:
        print 'Box size: ',(system.box[0],system.box[1],system.box[2])
        ofile=open(system.RDFOutputFile,'a')
        ofile.write('Box size: %8.4f %8.4f %8.4f A\n' %(system.box[0],system.box[1],system.box[2]))
        ofile.close
    print "Elasped time:",time.time()-e0, "CPU time:",time.clock()-c0
except :#  MTE.MT_Exception:
    print "\nERROR \n"
    print "Unhandled Error happened: see traceback in the file {0}".format(input_file_name+'.err')
    ofile=open(input_file_name+'.err','wb') 
    ex_type, ex_message, ex_traceback=sys.exc_info()
    ofile.write('Type: {0}\nMessage: {1}\n\n'.format(ex_type,ex_message))
    traceback.print_tb(ex_traceback,file=ofile)
    ofile.close()
