subroutine IMC_build_matrix(NSType, NA, NBond,IndexGlobNB_riSjS, IndexGlobB_riBond, NPointsPotB, &
     IND, INDI,CORS, CORP, NMIN, FNR, iPrint, stdout)
!Global
integer(8),allocatable:: CORS(:), CORP(:,:)
integer(4) NSType, NA, NBond, iPrint,stdout
integer(4), allocatable:: IND(:,:,:), INDI(:,:), NMIN(:)
integer(4),allocatable:: IndexGlobNB_riSjS(:,:,:), IndexGlobB_riBond(:,:), NPointsPotB(:)
real(8) FNR
!Local
integer(4) IC,JC, I,J, NR, iBond, iNSType, jNSType
! Count array dimensions (number of equations in the linear system) IC
IC=0
do iNSType=1, NSType
    do jNSType=1, iNSType                                 
        do NR=1, NA
          if ((IND(NR, iNSType, jNSType).eq.1).and.&
            (CORS(IndexGlobNB_riSjS(NR, iNSType, jNSType)).ne.0)) IC=IC+1
        enddo
    enddo
enddo
do iBond=1, NBond
    do NR=1, NPointsPotB(iBond)
        if((INDI(NR,iBond).eq.1).and.(CORS(IndexGlobB_riBond(NR, iBond)).ne.0).and.(NR.ne.NMIN(iBond))) IC=IC+1
    enddo
enddo
!write(*,*) 'IC=',IC

NUR=IC ! Number of equations in the system
! Allocate arrays
allocate(DIFF(NUR)); allocate(CROSS(NUR,NUR)); allocate(IUCMP(NUR)); allocate(IICMP(size(CORS))); allocate(IPVT(NUR))
DIFF(:)=0.d0; CROSS(:,:)=0.d0; IPVT(:)=0; IICMP(:)=0; IUCMP(:)=0;


IC=0
do iNSType=1, NSType
    do jNSType=1, iNSType                                 
        do NR=1, NA
          i=IndexGlobNB_riSjS(NR, iNSType, jNSType)
          if ((IND(NR, iNSType, jNSType).eq.1).and.(CORS(I).ne.0)) then
            IC=IC+1
            IUCMP(IC)=I            
            IICMP(I)=IC
            DIFF(IC)=COR(I)
          endif
        enddo
    enddo
enddo
write(stdout,*) 'Number of equations due to intermolecular/nonbonded terms: ',IC
do iBond=1, NBond
    do NR=1, NPointsPotB(iBond)
        I=IndexGlobB_riBond(NR, iBond)
        if((INDI(NR,iBond).eq.1).and.(CORS(I).ne.0)) then
            if(NR.eq.NMIN(iBond))then
               write((stdout),*)' Point ',NR,' blocked for bond ', iBond
            else
               IC=IC+1
               IUCMP(IC)=I
               IICMP(I)=IC
               DIFF(IC)=COR(I)
            endif            
        endif
    enddo
enddo

NUR=IC
do IC=1,NUR
    I=IUCMP(IC)
    do JC=IC,NUR
        J=IUCMP(JC)
        if(I.gt.J)write(stdout,*)'  !!!  violation in uncompressing '
        CROSS(IC,JC) = CORP(I,J)*FNR-CORS(I)*CORS(J)*FNR**2
        CROSS(JC,IC)=CROSS(IC,JC)
    end do
end do
if(IPRINT.ge.8)then
    do IC=1,NUR
        I=IUCMP(IC)
        write(stdout,'(i4,10(200f10.6/4x))')I,(CROSS(IC,JC),JC=1,NUR)
    end do
end if
end subroutine IMC_build_matrix