subroutine IMC_SetCorrections(NSType, NA, NBond, DPOTM, IND, INDI, NMIN,&
            IndexGlobNB_riSjS, IndexGlobB_riBond, NPointsPotB, StateB_iBond, CORS,  &
            iPrint,stdout)
    
! Global
integer(8),allocatable:: CORS(:)
integer(4) NSType, NA, NBond, iPrint,stdout
integer(4), allocatable:: IND(:,:,:), INDI(:,:), NMIN(:)
integer(4),allocatable:: IndexGlobNB_riSjS(:,:,:), IndexGlobB_riBond(:,:), NPointsPotB(:), StateB_iBond(:)
real(8) DPOTM
! Local     
integer(4) IC, I, Npoints, iBond, iNSType, jNSType, NR    
real(8) CORMin, CORMax

COR(:)=0.d0
cor(IUCMP(1:NUR))=DIFF(1:NUR)

! Imputing correction to the excluded points of bonded potentials (near minimum of intramolecular potential)
do iBond=1,NBond
    if (BTEST(StateB_iBond(iBond),4).and.(.not.BTEST(StateB_iBond(iBond),2))) then ! If RDF is given and potential is not fixed
!                    write(*,*) iBond,IndexGlobB_riBond(NMIN(iBond),iBond), NMIN(iBond)
        if (NMIN(iBond).eq.1) then ! Left boundary case
            COR(IndexGlobB_riBond(NMIN(iBond),iBond))=COR(IndexGlobB_riBond(NMIN(iBond)+1,iBond))
        elseif (NMIN(iBond).eq.NPointsPotB(iBond)) then ! Right boundary case
            COR(IndexGlobB_riBond(NMIN(iBond),iBond))=COR(IndexGlobB_riBond(NMIN(iBond)-1,iBond))
        else
            COR(IndexGlobB_riBond(NMIN(iBond),iBond))=0.5*(COR(IndexGlobB_riBond(NMIN(iBond)-1,iBond))&
                                                  +COR(IndexGlobB_riBond(NMIN(iBond)+1,iBond)))
        endif
    endif
enddo

! Shifting correction to a zero level
do iBond=1,NBond ! Over all bonds
    NPoints=NPointsPotB(iBond)
    if (BTEST(StateB_iBond(iBond),4).and.(.not.BTEST(StateB_iBond(iBond),2))) then ! If RDF is given and potential is not fixed
        CORMin=minval(COR(IndexGlobB_riBond(1:NPoints,iBond)))
        CORMax=maxval(COR(IndexGlobB_riBond(1:NPoints,iBond)))
        if (CORMin*CORMax.gt.0) then ! Both min and max has same sign
            if (CORMax.lt.0) then ! Potential correction values are below zero
               COR(IndexGlobB_riBond(1:NPoints,iBond))=COR(IndexGlobB_riBond(1:NPoints,iBond))-CORMax
            elseif (CORMin.gt.0) then ! Potential correction values are below zero
               COR(IndexGlobB_riBond(1:NPOints,iBond))=COR(IndexGlobB_riBond(1:NPoints,iBond))-CORMin
            endif
        endif
    endif
enddo

    ! If potential is not prohibiting, but no pairs on this distance were found we lower the potential value in this point                
do iNSType=1, NSType
    do jNSType=1, iNSType                                 
        do NR=1, NA
          i=IndexGlobNB_riSjS(NR, iNSType, jNSType)
          if((IND(NR, iNSType, jNSType).eq.1).and.(CORS(I).eq.0)) COR(I)=-DPOTM          
        enddo
    enddo
enddo

do iBond=1, NBond
    do NR=1, NPointsPotB(iBond)
        I=IndexGlobB_riBond(NR, iBond)
        if((INDI(NR,iBond).eq.1).and.(CORS(I).eq.0)) COR(I)=-DPOTM
    enddo
enddo

end subroutine IMC_setCorrections


