! Subroutine check potential corrections for reaching the convergence level
subroutine CheckPotCorr(NameSType,RAS,PotCorrJourn,CORS,level,LMoveMType,lconv,&!Char+Float+Logic
    NSType,NA,iter,MTypeSType,NMolMType,IndexGlobNB_riSjS,IND,iSiteinBond,jSiteinBond,ITS,NPairsTotalBond,NPointsPotB,NPTT,IndexGlobB_riBond)!Int
    implicit none
!Global variables
    character*4, allocatable:: NameSType(:)
    real(8),allocatable:: RAS(:),PotCorrJourn(:,:)!,CORS(:)
    integer(8), allocatable:: CORS(:)
    real(8) level
    integer(4) NSType,NA,iter, NMolMType(:)
    integer(4), allocatable:: MTypeSType(:),IndexGlobNB_riSjS(:,:,:),IND(:,:,:),&
    iSiteinBond(:,:),jSiteinBond(:,:),ITS(:),NPairsTotalBond(:),&
    NPointsPotB(:),NPTT(:),IndexGlobB_riBond(:,:)    
    logical LMoveMType(:)
    logical lconv
!Local variables
    real(8) RIMN,RIMX,DRR,RR,k1_num,k1_den,k2_num,k2_den

    integer(4) IS,JS,npair,NR,IPP,NAM,NPOTS,IPT,i,IAT,JAT!,IT,JT
    real(8), allocatable:: potc(:,:,:,:)
    

    allocate(potc(iter,NA,NSType,NSType)) !Array for all potential correction information
    potc(:,:,:,:)=0.d0
    lconv=.true.
    !Get the potential in tabulated 4d-matrix form
    do IS=1,NSType
        !IT=MTypeSType(IS)
        do JS=IS,NSType
            !JT=MTypeSType(JS)
            k1_num=0.d0
            k1_den=0.d0
            k2_num=0.d0
            k2_den=0.d0
	    if((LMoveMType(MTypeSType(IS)).or.LMoveMType(MTypeSType(JS))).and. NMolMType(MTypeSType(IS))*NMolMType(MTypeSType(JS)).ge.1)then
                do NR=1,NA
                    if(IND(NR,IS,JS).eq.1) then
                        potc(:,NR,JS,IS)=PotCorrJourn(IndexGlobNB_riSjS(NR,IS,JS),1:iter)
! Calculte creteria 1st time
                        k1_num=k1_num+(abs(potc(iter,NR,JS,IS)-potc(iter-1,NR,JS,IS))*((RAS(NR)/RAS(NA))**2))
                        k1_den=k1_den+(abs(potc(iter,NR,JS,IS))*((RAS(NR)/RAS(NA))**2))
                        
! Calculate creteria 2nd time if enought statistics:
                        if (iter.gt.2) then
                            k2_num=k2_num+(abs(potc(iter-1,NR,JS,IS)-potc(iter-2,NR,JS,IS))*((RAS(NR)/RAS(NA))**2))
                            k2_den=k2_den+(abs(potc(iter-1,NR,JS,IS))*((RAS(NR)/RAS(NA))**2))
                        endif                            
                    endif
                end do
! Check first criteria
                if ((k1_num/k1_den).gt.level) then
                    write(6,*) 'Warning! Pair ',adjustl(NameSType(IS)),NameSType(JS),'do not pass conv criteria 1:',k1_num/k1_den
                    lconv=.false.
                endif
!Check second criteria
                if (iter.gt.2) then
                    if ((k2_num/k2_den).gt.level) then
                        write(6,*) 'Warning! Pair ',adjustl(NameSType(IS)),NameSType(JS),&
                        'do not pass conv criteria 2:',k2_num/k2_den
                        lconv=.false.
                    endif
                endif
	    end if
	end do
    end do
    deallocate(potc)
   
end subroutine

subroutine EigenVectorStudy(MixEV, CROSS, NUR, NSType, NA, NPointsGlobNB,NameSType,  IUCMP, IICMP, ITYP1, ITYP2, IndexGlobNB_riSjS,&
    iPrint, stdout)
    ! Global variables
    integer(4) iPrint,stdout
    integer(4) NPointsGlobNB,NSType,NA, NUR
    integer(4), allocatable:: IICMP(:),IUCMP(:), ITYP1(:),ITYP2(:), IndexGlobNB_riSjS(:,:,:)
    real(8),allocatable::CROSS(:,:)
    real(8) MixEV
    character(atom_name_len), allocatable:: NameSType(:)
    ! Local Variables
    integer(4) m,lwork,liwork,npt1,npt2,i,j, k,l, IC, info
    integer(4), allocatable:: iwork(:),isuppz(:),indx(:)
    real(8), allocatable:: a(:,:),work(:),w(:),z(:,:)
    character*20 FMT ! temporary variable for output format string

    allocate(a(NUR,NUR),w(NUR),z(NUR,NUR),isuppz(2*2*NUR),indx(10))
    a(:,:)=0.d0
    w(:)=0.d0
    z(:,:)=0.d0
    isuppz(:)=0
    indx(:)=0
    do i=1,NUR
        do j=i,NUR
            a(i,j)=CROSS(i,j)
        enddo
    enddo
    write(stdout,*) 'IMC EIGEN DEBUG info: ',info,' lwork=',lwork,'liwork=',liwork
    call dsyevr('V','A','U',NUR,a,NUR,0.0,0.0,0,0,0.0,m,w,z,NUR,isuppz,lwork,-1,liwork,-1,info)
    write(stdout,*) 'IMC EIGEN DEBUG info: ',info,' lwork=',lwork,'liwork=',liwork
    lwork=26*nur
    allocate(work(lwork),iwork(liwork))
    work(:)=0.d0
    iwork(:)=0
    call dsyevr('V','A','U',NUR,a,NUR,0.0,0.0,0,0,0.0,m,w,z,NUR,isuppz,work,lwork,iwork,liwork,info)
    if (info.eq.0) then
        IC=0
        do j=1, NUR
            if ( ((maxval(abs(z(:,j))).lt.0.5).and.(maxval(abs(z(:,j))).gt.0.1 )) ) then
                IC=IC+1
                indx(IC)=j
                if (IC.ge.10) exit
            endif
        enddo
        if (IC.eq.0) then
            write(stdout,*) "IMC LEV no good eigenvectors"
        else
            WRITE(FMT,*) IC
            WRITE(*,"("//ADJUSTR(FMT)//"E12.4)") (w(indx(j)),j=1,IC)
!                    write(*,'( <IC>E12.4)') (w(indx(j)),j=1,IC)
            npt1=0
            do k=1,NSType
                do l=k,NSType
                    write(*,*) NameSType(k),"  ",NameSType(l)
                    do i=1, NUR
                        if ((IUCMP(i).le.NPointsGlobNB).and.((ITYP1(IUCMP(i)).eq.k)&
                        .and.((ITYP2(IUCMP(i)).eq.l))).or.((ITYP2(IUCMP(i)).eq.k)&
                        .and.((ITYP1(IUCMP(i)).eq.l)))) then
                            WRITE(FMT,*) IC
                            WRITE(stdout,"(3a4,i6,"//ADJUSTR(FMT)//"E12.4)") "EV: ",&
                                NameSType(k),NameSType(l),i, (z(i,indx(j)),j=1,IC)
!                                    write(stdout,'(3a4,i6, <IC>E12.4)') "EV: ",NameSType(k),NameSType(l),i, (z(i,indx(j)),j=1,IC)
                            npt1=npt1+1
                        endif
                    enddo
                enddo
            enddo
            npt2=0
            do k=1,NSType
                do l=k,NSType
                    do i=1,NA
                        if ((IICMP(IndexGlobNB_riSjS(i,k,l)).ne.0).and.(IICMP(IndexGlobNB_riSjS(i,k,l)).le.NPointsGlobNB)) npt2=npt2+1
                    enddo
                enddo
            enddo
            write(stdout,*) "IMC LEV  NPT1:",npt1, "NPT2:",npt2
            do IC=1,NUR
                COR(IUCMP(IC))=MixEV*z(IC,indx(1))
            end do
        endif
    else
        write(stdout,*) 'IMC EIGEN DEBUG info: ',info
        deallocate(a,w,z,isuppz)
    endif
end subroutine

! Subroutine writes potential correction journal to the specified output file *.potcorrcheck.
subroutine WritePotCorrCheck(BaseOutFileName,IREP,NameSType,NameSite,RAS,PotCorrJourn,RMinPotB,RMaxPotB,CORS,LMoveMType,&!Char+Float+Logic
    NSType,NA,NAV,iter,NBond,MTypeSType,NMolMType,IndexGlobNB_riSjS,npairsrdf,IND,iSiteinBond,jSiteinBond,&
    ITS,NPairsTotalBond,NPointsPotB,NPTT,IndexGlobB_riBond)!Int
!Global variables
    implicit none
    character BaseOutFileName*64
    character*4, allocatable:: NameSType(:),NameSite(:)
    real(8) RAS(:),PotCorrJourn(:,:),RMinPotB(:),RMaxPotB(:)!,CORS(:)
    integer(8), allocatable:: CORS(:)
    integer(4) NSType,NA,NAV,iter,NBond,NMolMType(:),IREP
    integer(4), allocatable:: MTypeSType(:), IndexGlobNB_riSjS(:,:,:),IND(:,:,:),&
    iSiteinBond(:,:),jSiteinBond(:,:),ITS(:),NPairsTotalBond(:),&
    NPointsPotB(:),NPTT(:),IndexGlobB_riBond(:,:)
    integer(8),allocatable:: npairsrdf(:,:)
    logical LMoveMType(:)
!Local variables
    real(8) RIMN,RIMX,DRR,RR
    character SaveFileName*64, FMT*20
    integer(4) IS,JS,IT,JT,npair,NR,IPP,NAM,NPOTS,IPT,i,IAT,JAT

    SaveFileName=BaseOutFileName
    SaveFileName(Len_Trim(SaveFileName)+1:Len_Trim(SaveFileName)+2)='.i'
    write(SaveFileName(Len_Trim(SaveFileName)+1:Len_Trim(SaveFileName)+3),'(i0.3)') IREP
    SaveFileName(Len_Trim(SaveFileName)+1:Len_Trim(SaveFileName)+13)='.potcorrcheck'
    open(unit=2,file=SaveFileName(1:Len_Trim(SaveFileName)),status='unknown')
    write(6,*)'opening file ',SaveFileName(1:Len_Trim(SaveFileName)),' to write Potential correction convergence check results'
    do IS=1,NSType
        IT=MTypeSType(IS)
        do JS=IS,NSType
            JT=MTypeSType(JS)
	    if((LMoveMType(IT).or.LMoveMType(JT)).and. NMolMType(IT)*NMolMType(JT).ge.1)then
                if (IS.eq.JS) then
                    npair=npairsrdf(IS,JS)+sum(CORS(IndexGlobNB_riSjS(1:NA,IS,JS)))
                else
                    npair=npairsrdf(IS,JS)+sum(CORS(IndexGlobNB_riSjS(1:NA,IS,JS)))+npairsrdf(JS,IS)
                endif
                npair=npair/NAV
                do NR=1,NA
                    if(IND(NR,IS,JS).eq.1)then
                        WRITE(FMT,*) iter
                        WRITE(2,"(3a4,a1,f5.2,"//ADJUSTR(FMT)//"f8.4)") &
!                        write(2,'(3a4,a1,f5.2,<iter>f8.4)') &
                        'pot:',adjustl(NameSType(IS)),NameSType(JS),';', RAS(NR),&
                        (PotCorrJourn(IndexGlobNB_riSjS(NR,IS,JS),i), i=1,iter)
                    end if
                end do
	    end if
	end do
    end do
   !Intramolecular potentials:'
    do IPP=1,NBond
       IAT=iSiteinBond(IPP,1)
       JAT=jSiteinBond(IPP,1)
       IT=ITS(IAT)
       if(LMoveMType(IT))then
           NPAIR=NPairsTotalBond(IPP)
           NAM=NPointsPotB(IPP)
           RIMN=RMinPotB(IPP)
           RIMX=RMaxPotB(IPP)
           DRR=(RIMX-RIMN)/NAM
           NPOTS=NPTT(IPP)
           if(NAM.gt.1)then
!                  write(*,*)' This pair:',NameSite(IAT),' - ',NameSite(JAT)
!                  write(*,*)'   R       RDF    RDFref   Potential     Init.Pot.'
!                  write(2,'(4i5,2f10.4)')NPOTS,IAT,JAT,NAM,RIMN,RIMX
!                  do I=1,NPOTS
!                     write(2,'(2i5)') iSiteinBond(IPP,I),jSiteinBond(IPP,I)
!                  end do
              do NR=1,NAM
                  RR=RIMN+DRR*(NR-0.5)
                  IPT=IndexGlobB_riBond(NR,IPP)
                  WRITE(FMT,*) iter
                  WRITE(2,'(a10,2a4,a1,f5.2,'//ADJUSTR(FMT)//"f7.3)") 'pot_intra:',adjustl(NameSite(IAT)),NameSite(JAT),';', &
                     RR,(PotCorrJourn(IPT,i), i=1,iter)

!                  write(2,'(a10,2a4,a1,f5.2,<iter>f7.3)') 'pot_intra:',adjustl(NameSite(IAT)),NameSite(JAT),';', &
!                     RR,(PotCorrJourn(IPT,i), i=1,iter)
              end do
           end if
       end if
    end do
    close(2)
end subroutine
