subroutine Initiate(NSType, NactNB, NBond, NBondB, NBondA, BTypeBond, MTypeBond, NameMType, NA, POTCUT,FRT, &
    NameSType, &
    LReadRDF, LReadPot,&
    StateNB_iSjS,StateB_iBond,&
    RDFref_NB_riSjS,PotNB_RiSjS,RDFref_B_riBond, PotB_riBond,rPotB_riBond,i_SiteInBond,j_SiteInBond,&    
    IND, INDI, &
    NPointsRDFNB,NPointsPotNB, RMaxRDFNB, RMaxPotNB, RMinRDFNB, RMinPotNB,&
    NPointsRDFB,NPointsPotB,RMaxRDFB,RMaxPotB,RMinRDFB,RMinPotB, &
    LMoveMType, MTypeSType, &
    !NPointsGlobNB,  NPointsGlobTotal,
    IndexGlobNB_riSjS, IndexGlobB_riBond,&
    CORP, CORS, npairsrdf, LIMC, RCUT, RECUT, RDFINC)
    ! Global Variables
    integer NSType,NactNB, NBond,NBondB, NBondA, NA
    integer, allocatable:: &
        StateNB_iSjS(:,:), StateB_iBond(:),IND(:,:,:),INDI(:,:),BTypeBond(:),MTypeBond(:),&
        NPointsRDFB(:),NPointsPotB(:),i_SiteInBond(:,:), j_SiteInBond(:,:)       
    real(8) POTCUT, FRT, RCUT, RECUT, RDFINC
    real(8), allocatable:: RDFref_NB_riSjS(:,:,:),PotNB_RiSjS(:,:,:),RDFref_B_riBond(:,:), PotB_riBond(:,:),rPotB_riBond(:,:)
    real(8), allocatable::RMaxRDFB(:),RMinRDFB(:),RMaxPotB(:),RMinPotB(:)
    integer NPointsRDFNB, NPointsPotNB
    real(8) RMaxRDFNB, RMinRDFNB, RMaxPotNB, RMinPotNB    
    integer, allocatable:: IndexGlobNB_riSjS(:,:,:), IndexGlobB_riBond(:,:),&
        MTypeSType(:)
    integer NPointsGlobNB, NPointsGlobB, NPointsGlobTotal
    character(atom_name_len), allocatable:: NameSType(:)
    character(filename_text) NameMType(:)
    logical LMoveMType(:), LReadRDF, LReadPot, LIMC
    integer(8), allocatable::&
        CORS(:),&           ! <S_i> - local value for each process (in MPI case)
        CORP(:,:),&         ! <S_i*S_j>    local value for each process (in MPI case)
        npairsrdf(:,:) ! Arrays for counting number of pairs for intermolecular RDFs for normalization.
    ! Local Variables
    integer iNSType,jNSType, iBond, iNA, iR,i, np
    real(8), allocatable:: tmpU(:)
    real(8) dr
    
    ! Check if Potentials and RDFs files were read
    if (.not.(LReadRDF.or.LReadPot)) then 
        write(stdout,*) "Error: Neither RDF nor potential file were stated to read"
        stop
    endif
    ! Check if Potential file was not read
    if (.not.(LReadPot)) then 
        write(stdout,*) "Potential file was not stated to read. Initiate parameters from the RDFs"
        RMaxPotNB=RMaxRDFNB
        RMinPotNB=RMinRDFNB
        NPointsPotNB=NPointsRDFNB
    endif
    ! Check if RDF file was not read
    if (.not.(LReadRDF)) then 
        write(stdout,*) "RDF file was not stated to read. Are you sure that you want to continue doing a single Monte Carlo run?"
        RMaxRDFNB=RMaxPotNB
        RMinRDFNB=RMinPotNB
        NPointsRDFNB=NPointsPotNB
    endif
    ! Check if RMin/RMax and Npoints for NB RDF and potentials are the same
    if ((RMaxRDFNB.ne.RMaxPotNB).or.(RMinPotNB.ne.RMinRDFNB).or.(NPointsRDFNB.ne. NPointsPotNB)) then
        write(stdout,*) "Error: Parameters (RMin,RMax,NPoints) stated for NB-RDFs differs from parameters stated for NB-potentials"
        stop
    endif
    if (.not. allocated(RDFref_NB_riSjS)) allocate(RDFref_NB_riSjS(NPointsRDFNB,NSType,NSType))
    if (.not. allocated(PotNB_riSjS)) allocate(PotNB_riSjS(NPointsPotNB,NSType,NSType))   
    ! loop over all pairs of site types
    write(stdout,*) ''
    write(stdout,*) "Intermolecular interactions: ", NSType, ' Site Types, gives ',&
       NSType*(NSType+1)/2,' NB - pair potentials to define.'
    if (.not. allocated(IND)) allocate(IND(NA,NSType,NSType))
    IND(:,:,:)=-1
    NactNB=0
    do iNSType=1, NSType        
        do jNSType=iNSType, NSType
            NactNB=NactNB+1 ! By default count NB-interactions which are non-zero
            write(stdout,*) "Site Types pair: ", trim(NameSType(iNSType)),'-',trim(NameSType(jNSType)) 
            ! Case one - NoRDF no Potential -> No interaction
            if (StateNB_iSjS(iNSType,jNSType).lt.4) then
                write(stdout,*)'  Neither RDF nor Potential are defined: No short-range interaction between the site types.'
                NactNB=NactNB-1 ! take away this pair from the NB interaction counter
                IND(1:NA,iNStype,jNSType)=-2
                PotNB_RiSjS(1:NA,iNSType,jNSType)=0.d0                        
                continue
            endif
            
            ! Case two - RDF stated, but Potential is absent -> Initialize potential
            if (BTest(StateNB_iSjS(iNSType,jNSType),4).and.(.not.BTest(StateNB_iSjS(iNSType,jNSType),3))) then
                write(stdout,'(a)',advance='no')'  RDF is defined, but Potential is not defined for this pair:'
                if (BTest(StateNB_iSjS(iNSType,jNSType),1)) then
                    write(stdout,*) 'Initialize the potential with PMF'                            
                else ! If initialize with zero
                    write(stdout,*) 'Initialize the potential with zero'
                endif                                                                
                ! Loop over all points of the potential
                do iNA=1, NA
                    if (RDFref_NB_riSjS(iNA,iNSType,jNSType).gt.0.d0) then ! RDF has a nonzero value at this point
                        ! Mark the point as allowed for inverse
                        IND(iNA,iNSType,jNSType)=1                        
                        if (BTest(StateNB_iSjS(iNSType,jNSType),1)) then ! If initialize with PMF
                            PotNB_RiSjS(iNA,iNSType,jNSType)=-dlog(RDFref_NB_riSjS(iNA,iNSType,jNSType))                            
                        else ! If initialize with zero
                            PotNB_RiSjS(iNA,iNSType,jNSType)=0.0 
                        endif
                    else !RDF has a zero value at this point
                        PotNB_RiSjS(iNA,iNSType,jNSType)=POTCUT+100.0*(NA-iNA) ! Some large prohibiting value, which decays 
                        IND(iNA,iNSType,jNSType)=0 ! Excluded from inverse
                    endif
                enddo
                StateNB_iSjS(iNSType,jNSType)=ibset(StateNB_iSjS(iNSType,jNSType),3) ! Mark that potential is defined

                if(BTest(StateNB_iSjS(iNSType,jNSType),2)) then ! Fixed potential
                    write(stdout,*)' The Potential is stated to be fixed and will be excluded from the inverse procedure'                    
                    IND(1:NA,iNSType,jNSType)=-3
                else ! Non fixed potential
                    write(stdout,*)' The potential is not fixed. Inverse mode is enabled for it.'                    
                endif
                continue
            
            ! Case three - No RDF, but Potential is stated -> Fixed potential, no inverse
            elseif (BTest(StateNB_iSjS(iNSType,jNSType),3).and.(.not.BTest(StateNB_iSjS(iNSType,jNSType),4))) then
                write(stdout,'(a)',advance='no')'  RDF is not defined, but Potential is defined for this pair:'
                write(stdout,*)' The points will be excluded from the inverse procedure'
                IND(1:NA,iNSType,jNSType)=-4
                PotNB_RiSjS(1:NA,iNSType,jNSType)=PotNB_RiSjS(1:NA,iNSType,jNSType)/FRT
                continue
            
            ! Case four - RDF and Potential are stated
            elseif (BTest(StateNB_iSjS(iNSType,jNSType),3).and.(BTest(StateNB_iSjS(iNSType,jNSType),4))) then
                write(stdout,'(a)',advance='no')'  RDF and Potential are defined for this pair:'
                PotNB_RiSjS(1:NA,iNSType,jNSType)=PotNB_RiSjS(1:NA,iNSType,jNSType)/FRT
                if(BTest(StateNB_iSjS(iNSType,jNSType),2)) then ! Fixed potential
                    write(stdout,*)' The Potential is stated to be fixed. The points will be excluded from the inverse procedure'                    
                    IND(1:NA,iNSType,jNSType)=-3
                else ! Non fixed potential
                    write(stdout,*)' The potential is not fixed. Inverse mode is enabled'                    
                    do iNA=1, NA
                        if (RDFref_NB_riSjS(iNA,iNSType,jNSType).gt.0.d0) then ! RDF has a nonzero value at this point
                        ! Mark the point as allowed for inverse
                            IND(iNA,iNSType,jNSType)=1                        
                        else ! Block point for inverse
                            IND(iNA,iNSType,jNSType)=0                        
                        endif                        
                    enddo
                endif                
            endif
            
            ! Keep the symmetry of the matrixes            
            PotNB_RiSjS(1:NA,jNSType,iNSType)=PotNB_RiSjS(1:NA,iNSType,jNSType)
            IND(1:NA,jNSType,iNSType)=IND(1:NA,iNSType,jNSType)
            StateNB_iSjS(jNSType,iNSType)=StateNB_iSjS(iNSType,jNSType)
            write(stdout,*) ''            
        enddo        
    enddo

    write(stdout,*) ''
    write(stdout,*) "Intramolecular bonds: ",NBond,' in total'
    write(stdout,*) NBondB,' pairwise and ',NBondA,' angle-bending bonds to be defined'
!    write(stdout,*) ''    
!    call reshape2(INDI,size(RDFref_B_riBond,1),size(RDFref_B_riBond,2))
!    INDI(:,:)=-1
    call reshape2(INDI,max(maxval(NPointsPotB(:)),maxval(NPointsRDFB(:)),1),NBond)
    INDI(:,:)=-1

    ! Loop over all bonds   
    do iBond=1, NBond        
        write(stdout,'(a,i3,a,a,a1)',advance='no') "Bond ", iBond, ' belongs to Molecular Type ',&
            trim(NameMType(MTypeBond(iBond))),':'
        select case (BTypeBond(iBond))
            case(1)
                write(stdout,*) "Pairwise Bond "
            case(2)
                write(stdout,*) "Angle-bending (angular) Bond "
            case default
                stop 'unknown bond type'                
        end select
        
        ! Case one - NoRDF no Potential -> No interaction
        if (StateB_iBond(iBond).lt.4) then
                write(stdout,*)'ERROR: Neither RDF nor Potential are defined for this bond.'                
                stop
                
        ! Case two - RDF stated, but Potential is absent -> Initialize potential
        elseif (BTest(StateB_iBond(iBond),4).and.(.not.BTest(StateB_iBond(iBond),3))) then
            write(stdout,'(a)',advance='no')'   RDF is defined, but Potential is not defined for this bond:'
            if (BTest(StateB_iBond(iBond),1)) then
                write(stdout,*) ' Initialize the potential with PMF'                            
            else ! If initialize with zero
                write(stdout,*) ' Initialize the potential with zero'
            endif                                                                

            ! Get parameters from the according RDF
            NPointsPotB(iBond)=NPointsRDFB(iBond)
            RMaxPotB(iBond)=RMaxRDFB(iBond)
            RMinPotB(iBond)=RMinRDFB(iBond)
            ! Reshape arrays for potential/distance
            call reshape2(PotB_riBond,NPointsPotB(iBond),NBond)
            call reshape2(rPotB_riBond,NPointsPotB(iBond),NBond)
!            call reshape2(INDI,NPointsPotB(iBond),iBond); INDI(:,iBond)=-1
            ! Loop over all points                                               
            do iR=1,  NPointsPotB(iBond)
                if (RDFref_B_riBond(iR,iBond).gt.0.d0) then ! RDF has a nonzero value at this point
                    ! Mark the point as allowed for inverse
                    INDI(iR,iBond)=1                        
                    if (BTest(StateB_iBond(iBond),1)) then ! If initialize with PMF
                        PotB_riBond(iR,iBond)=-dlog(RDFref_B_riBond(iR,iBond))                            
                    else ! If initialize with zero
                        PotB_riBond(iR,iBond)=0.0 
                    endif
                else !RDF has a zero value at this point
                    ! PotB_iBond(iR,iBond)=FCUT*abs(NPointsPotB(iBond)/2.0-)+100.0*(NA-iNA) ! Some large prohibiting value, which decays 
                    INDI(iR,iBond)=0 ! Excluded from inverse
                    write(stdout,*) 'ERROR: RDF for the bond has a zero value at point r=',&
                                RMinRDFB(iBond)+(iR-0.5)*(RMaxRDFB(iBond)-RMaxRDFB(iBond))/NPointsRDFB(iBond)
                    stop
                endif
            enddo
            StateB_iBond(iBond)=iBset(StateB_iBond(iBond),3)

            if(BTest(StateB_iBond(iBond),2)) then ! Fixed potential
                write(stdout,*)'The Potential is stated to be fixed and will be excluded from the inverse procedure.'                    
               INDI(1:NPointsPotB(iBond),iBond)=-3
            else ! Non fixed potential
                write(stdout,*)' The potential is not fixed. Inverse mode is enabled for it.'                    
                do iNA=1, NPointsPotB(iBond)
                    if (RDFref_B_riBond(iNA,iBond).gt.0.d0) then ! RDF has a nonzero value at this point
                    ! Mark the point as allowed for inverse
                        INDI(iNA,iBond)=1                        
                    else ! Block point for inverse
                        INDI(iNA,iBond)=0                        
                    endif                        
                enddo
            endif                

            continue

    ! Case three - No RDF, but Potential is stated -> Fixed potential, no inverse
        elseif (BTest(StateB_iBond(iBond),3).and.(.not.BTest(StateB_iBond(iBond),4))) then
            write(stdout,'(a)',advance='no')'  RDF is not defined, but Potential is defined for this bond: '
            write(stdout,*)'The points will be excluded from the inverse procedure'
!            call reshape2(INDI,NPointsPotB(iBond),iBond); INDI(:,iBond)=-1
            INDI(1:NPointsPotB(iBond),iBond)=-4
            PotB_riBond(1:NPointsPotB(iBond),iBond)=PotB_riBond(1:NPointsPotB(iBond),iBond)/FRT
            continue

    ! Case four - RDF and Potential are stated
        elseif (BTest(StateB_iBond(iBond),3).and.(BTest(StateB_iBond(iBond),4))) then
            write(stdout,*)'RDF and Potential are defined for this pair:'
            PotB_riBond(1:NPointsPotB(iBond),iBond)=PotB_riBond(1:NPointsPotB(iBond),iBond)/FRT
            if(BTest(StateB_iBond(iBond),2)) then ! Fixed potential
                write(stdout,*)'The Potential is stated to be fixed. The points will be excluded from the inverse procedure'                    
                if (RMinRDFB(iBond).lt.RMinPotB(iBond)) then
                    write(stdout,*) 'Bond',iBond,': RMinRDF=',RMinRDFB(iBond),' is smaller than RMinPot',RMinPotB(iBond)
                    write(stdout,*) 'RDF min range will be shifted/cut to ',RMinPotB(iBond)
                    dr=(RMaxRDFB(iBond)-RMinRDFB(iBond))/NPointsRDFB(iBond)
                    np=nint((RMinPotB(iBond)-RMinRDFB(iBond))/dr)
                    write(stdout,*) np,' points will be cut of the left tail of the RDF'
                    RMinRDFB(iBond)=RMinPotB(iBond)
                    call reshape(tmpU,NPointsRDFB(iBond)-np)
                    tmpU(:)=RDFref_B_riBond(np+1:NPointsRDFB(iBond),iBond)                    
                    RDFref_B_riBond(:,iBond)=0                    
                    NPointsRDFB(iBond)=NPointsRDFB(iBond)-np
                    RDFref_B_riBond(1:NPointsRDFB(iBond),iBond)=tmpU(:)
                    deallocate(tmpU)
                endif
                if (RMinRDFB(iBond).gt.RMinPotB(iBond)) then
                    write(stdout,*) 'Bond',iBond,': RMinRDF=',RMinRDFB(iBond),' is larger than RMinPot',RMinPotB(iBond)
                    write(stdout,*) 'RDF min range will be extended to ',RMinPotB(iBond),' and filled with zeros'
                    call reshape(tmpU,NPointsRDFB(iBond))
                    tmpU(:)=RDFref_B_riBond(1:NPointsRDFB(iBond),iBond)
                    call reshape2(RDFref_B_riBond,NPointsPotB(iBond), NBond)                    
                    dr=(RMaxRDFB(iBond)-RMinRDFB(iBond))/NPointsRDFB(iBond)
                    np=nint((RMinRDFB(iBond)-RMinPotB(iBond))/dr)
                    write(stdout,*) np,' zero points will be added to the left tail of RDF'
                    RMinRDFB(iBond)=RMinPotB(iBond)
                    RDFref_B_riBond(1:np,iBond)=0.0
                    RDFref_B_riBond(np+1:np+NPointsRDFB(iBond),iBond)=tmpU(:)
                    NPointsRDFB(iBond)=np+NPointsRDFB(iBond)
                    deallocate(tmpU)
                endif
                
                if (RMaxRDFB(iBond).gt.RMaxPotB(iBond)) then
                    write(stdout,*) 'Bond',iBond,': RMaxRDF=',RMaxRDFB(iBond),' is larger than RMaxPot',RMaxPotB(iBond)
                    write(stdout,*) 'RDF max range will be shifted/cut to ',RMaxPotB(iBond)
                    dr=(RMaxRDFB(iBond)-RMinRDFB(iBond))/NPointsRDFB(iBond)
                    np=nint((RMaxRDFB(iBond)-RMaxPotB(iBond))/dr)
                    write(stdout,*) np,' points will be cut of the right tail of the RDF'
                    call reshape(tmpU,NPointsRDFB(iBond)-np)
                    tmpU(:)=RDFref_B_riBond(1:NPointsRDFB(iBond)-np,iBond)                    
                    RDFref_B_riBond(:,iBond)=0                    
                    NPointsRDFB(iBond)=NPointsRDFB(iBond)-np
                    RDFref_B_riBond(1:NPointsRDFB(iBond),iBond)=tmpU(:)
                    RMaxRDFB(iBond)=RMaxPotB(iBond)
                    deallocate(tmpU)
                endif
                
                if (RMaxRDFB(iBond).lt.RMaxPotB(iBond)) then
                    write(stdout,*) 'Bond',iBond,': RMaxRDF=',RMaxRDFB(iBond),' is smaller than RMaxPot',RMaxPotB(iBond)
                    write(stdout,*) 'RDF max range will be extended to ',RMaxPotB(iBond),' and filled with zeros'
                    call reshape(tmpU,NPointsRDFB(iBond))
                    tmpU(:)=RDFref_B_riBond(1:NPointsRDFB(iBond),iBond)
                    call reshape2(RDFref_B_riBond,NPointsPotB(iBond), NBond)                    
                    dr=(RMaxRDFB(iBond)-RMinRDFB(iBond))/NPointsRDFB(iBond)
                    np=nint((RMaxPotB(iBond)-RMaxRDFB(iBond))/dr)
                    write(stdout,*) np,' zero points will be added to the right tail of RDF'
                    RMaxRDFB(iBond)=RMaxPotB(iBond)
                    RDFref_B_riBond(1:NPointsRDFB(iBond)+np,iBond)=0.0
                    RDFref_B_riBond(1:NPointsRDFB(iBond),iBond)=tmpU(:)
                    NPointsRDFB(iBond)=np+NPointsRDFB(iBond)
                    deallocate(tmpU)
                endif
                if (NPointsRDFB(iBond).ne.NPointsPotB(iBond)) then
                    write(stdout,*) 'ERROR Initiate: Bond',iBond,' NPointsRDFB(iBond) ',NPointsRDFB(iBond),&
                        '.ne.NPointsPotB(iBond) ',NPointsPotB(iBond)
                    stop
                endif
                    
!                call reshape2(INDI,NPointsPotB(iBond),iBond); INDI(:,iBond)=-1    
                INDI(1:NPointsPotB(iBond),iBond)=-3
            else ! Non fixed potential
                write(stdout,*)' The potential is not fixed. Inverse mode is enabled'      
!                call reshape2(INDI,NPointsPotB(iBond),iBond); INDI(:,iBond)=-1
                do iNA=1, NPointsPotB(iBond)
                    if (RDFref_B_riBond(iNA,iBond).gt.0.d0) then ! RDF has a nonzero value at this point
                    ! Mark the point as allowed for inverse
                        INDI(iNA,iBond)=1                        
                    else ! Block point for inverse
                        INDI(iNA,iBond)=0                        
                    endif                        
                enddo
            endif                
            ! Check consistency of RMax,RMin,Npoints
            if (.not. BTest(StateB_iBond(iBond),2)) then
                if (NPointsPotB(iBond).ne.NPointsRDFB(iBond)) then
                    write(stdout,*) 'ERROR: Number of points stated in RDF ',NPointsRDFB(iBond),&
                                ' and in Potential ',NPointsPotB(iBond),' for this bond are inconsistent '
                    stop
                endif
                if (RMaxPotB(iBond).ne.RMaxRDFB(iBond)) then
                    write(stdout,*) 'ERROR: RMax stated in RDF ',RMaxRDFB(iBond),&
                                ' and in Potential ',RMaxPotB(iBond),' for this bond are inconsistent '
                    stop
                endif
                if (RMinPotB(iBond).ne.RMinRDFB(iBond))then
                    write(stdout,*) 'ERROR: RMin stated in RDF ',RMinRDFB(iBond),&
                                ' and in Potential ',RMinPotB(iBond),' for this bond are inconsistent '
                    stop
                endif
            else
                                if (NPointsPotB(iBond).ne.NPointsRDFB(iBond)) then
                    write(stdout,*) 'WARNING: Number of points stated in RDF ',NPointsRDFB(iBond),&
                                ' and in Potential ',NPointsPotB(iBond),' for this bond are inconsistent '
                    write(stdout,*) 'Since the potential is FIXED, the RDF is excluded from inverse procedure.'
                endif
                if (RMaxPotB(iBond).ne.RMaxRDFB(iBond)) then
                    write(stdout,*) 'ERROR: RMax stated in RDF ',RMaxRDFB(iBond),&
                                ' and in Potential ',RMaxPotB(iBond),' for this bond are inconsistent '
                    write(stdout,*) 'Since the potential is FIXED, the RDF is excluded from inverse procedure.'
                endif
                if (RMinPotB(iBond).ne.RMinRDFB(iBond))then
                    write(stdout,*) 'ERROR: RMin stated in RDF ',RMinRDFB(iBond),&
                                ' and in Potential ',RMinPotB(iBond),' for this bond are inconsistent '
                    write(stdout,*) 'Since the potential is FIXED, the RDF is excluded from inverse procedure.'
                endif
            endif

        endif ! End of four cases
        write(stdout,*) ''
    enddo ! End of loop over bonds
     
    ! Set 5th bit of the state-array for sitepairs if they are allowed to move or not
    do iNSType=1, NSType        
        do jNSType=1, iNSType                            
            if(LMoveMType(MTypeSType(iNSType)).or.LMoveMType(MTypeSType(jNSType))) then
                StateNB_iSjS(iNSType,jNSType)=ibset(StateNB_iSjS(iNSType,jNSType),5)
                StateNB_iSjS(jNSType,iNSType)=StateNB_iSjS(iNSType,jNSType)
            endif
        end do
    end do
        
    ! Populate global RDF arrays
    ! Construct Global RDF array
    NPointsGlobNB=0
    
    do iNSType=1, NSType        
        do jNSType=1, iNSType                            
            if(BTest(StateNB_iSjS(iNSType,jNSType),5)) NPointsGlobNB=NPointsGLobNB+NA
        end do
    end do
    do iBond=1, NBond
        if (LMoveMType(MTypeBond(iBond))) StateB_iBond(iBond)=ibset(StateB_iBond(iBond),5)
    enddo
!    call reshape(iRGlob,NPointsGlobNB)
!    call reshape(iSTypeGlobNB,NPointsGlobNB)
!    call reshape(jSTypeGlobNB,NPointsGlobNB)
!    call reshape(GlobRDF,NPointsGlobNB)
    if (.not. allocated(indexGlobNB_riSjS)) allocate(indexGlobNB_riSjS(NA,NSType,NSType))    
     i=0
    do iNSType=1, NSType        
        do jNSType=1, iNSType                                 
            do iNA=1,NA     
                i=i+1
                IndexGlobNB_riSjS(iNA,iNSType,jNSType)=i
                IndexGlobNB_riSjS(iNA,jNSType,iNSType)=i
!                iRGlob(i)=iNA
!                iSTypeGlobNB(i)=iNSType
!                jSTypeGlobNB(i)=jNSType
!                GlobRDF(i)=RDFref_NB_riSjS(iNA,iNSType,jNSType)
            enddo            
        enddo
     enddo
     
     NPointsGlobNB=i     
     NPointsGlobB=sum(NPointsRDFB(:))
     NPointsGlobTotal=NPointsGlobNB+NPointsGlobB    
     write(stdout,*)' NPointsGlobNB=',NPointsGlobNB,' NPointsGlobB=',NPointsGlobB,' NPointsGlobTotal=',NPointsGlobTotal 
     
!     call reshape2(IndexGlobB_riBond,MAXVAL(NPointsRDFB(:)),NBond)
     call reshape2(IndexGlobB_riBond,max(maxval(NPointsPotB(:)),maxval(NPointsRDFB(:)),1),NBond)
!     call reshape(iRGlob,NPointsGlobTotal)
!     call reshape(iSTypeGlobNB,NPointsGlobTotal)
!     call reshape(jSTypeGlobNB,NPointsGlobTotal)
!     call reshape(GlobRDF,NPointsGlobTotal)

     do iBond=1, NBond
         do iNA=1, NPointsRDFB(iBond)             
            i=i+1
            IndexGlobB_riBond(iNA,iBond)=i
!            iSTypeGlobNB(i)=i_SiteInBond(ibond,1)
!            jSTypeGlobNB(i)=j_SiteInBond(ibond,1)
!            iRGlob(i)=iNA
!            GlobRDF(i)=RDFref_B_riBond(iNA,iBond)
         enddo
     enddo
     
 ! And now we can allocate memory for structural average arrays               
    call reshape(CORS,NPointsGlobTotal)
    call reshape2(npairsrdf,NSType,NSType)    
    if (LIMC) call reshape2(CORP,NPointsGlobTotal,NPointsGlobTotal)
         
!  Different cut-offs
    RDFINC=RMaxRDFNB/NA        
!  short-range
    RCUT=RMaxRDFNB
!  electrostatic
    if(RECUT.le.RMaxRDFNB)RECUT=RMaxRDFNB
    
end subroutine Initiate
