!DEC$ FREEFORM
subroutine ReadInput(iFilename,&
            NMType,NameMType,NMolMType,LMoveMType,&
            BOXL,BOYL,BOZL,&
            EPS,TEMP,&
            NMKS, NMKS0, DR, MCTRANSSTEP, MCROTSTEP, ITRANS, IROT,&
            RECUT, NRS, POTCUT,AF, FQ, IOUT, &
            IAV,REGP, DPOTM, LCRD, LCRDPASS, RTM, IREPT, LIMC, IPOTCORRCHECK, LPotCorrCheck, PotCorrCheckLevel, &
            LEV,&
            FilRDF, FilPot,LRDF, LPOT, BaseOutFileName, FSTART,FCRD, LXMOL, ITR)
! Global Variables
    character(filename_text) iFilename, FilRDF, FilPot, BaseOutFileName, FSTART, FCRD
    integer(4) NMType, ITRANS, IROT, NRS, IAV, IREPT, IPOTCORRCHECK, ITR, IOUT
    character(filename_text), allocatable:: NameMType(:)
    logical, allocatable:: LMoveMType(:)
    integer(4), allocatable:: NMolMType(:)
    integer(8) NMKS, NMKS0
    real(8) BOXL,BOYL,BOZL, EPS, TEMP, DR, MCTRANSSTEP, MCROTSTEP, RECUT, POTCUT, AF, FQ,&
        REGP, DPOTM, RTM, PotCorrCheckLevel
    logical LIMC, LZeroPot, LCRD, LCRDPASS, LEV, LXMOL, LRDF, LPOT, LpotCorrCheck
!Local variables
    integer(4) iend, iostt, i, ierr,j, iNMType
    real(8) trand, W
    character(input_text) field, l, str, box(3)
    character(input_text), allocatable :: text(:)
    character(mol_name_len), allocatable:: NMolMTypestr(:), LMoveMTypeStr(:)
! Open the Input file and scan it  for number of lines (variable iend)
     write (stdout,*) ''
     write(stdout,*) '-----------------------------------------------------------------------'
     write (stdout,'(a)',advance='no') ' Reading main input file: '
    call GetFileLength(iFilename,iend,'main input')
    write (stdout,*) ''
    write (stdout,*) 'Parsing main input file'
    
! Allocate array for the content of the file    
    allocate(text(iend))
! Read the file to the array text
    open(unit=4,file=iFilename,status='old',iostat=iostt)
    do i=1, iend
        read(4,'(a)') l
        text(i)=trim(adjustl(l))
    enddo
    close(4)    

    call ReadParameter(iPrint, text, 'VerboseLevel', 'IPRINT',&
        'How much information to print',&
        'W',5)

    call ReadParameterInt(NMType, text, 'NMType', 'NTYP',&
        'Number of molecular types in the system',&
        'E',1)
! Set impossible defaults:
    BOXL=-1.d0
    BOZL=-1.d0
    BOYL=-1.d0
! Loop over all lines of the array
    i=1        
    do while (i.le.iend)
        call ReadLineFromText(text,i,str,ierr)
        l=str
!write(*,*) 'Debug readinput: line:',l,':'                
        call split(l,'=',field)
! NameMType  (NAMOL)    
!write(*,*) 'Debug readinput: field:',uppercase(trim(adjustl(field))),':'
        if ((uppercase(trim(adjustl(field)))=='NAMEMTYPE').or.(uppercase(trim(adjustl(field)))=='NAMOL')) then 
            allocate(NameMType(NMType))
        ! Clean l from possible begin and end symbols like ' and "
           call delall(l,'"')
           call delall(l,"'")

            call parse(l,',',NameMType, iNMType)
                if (iNMType.ne.NMType) then
                    write(stdout,*) 'ERROR: Reading Input: File: ',trim(iFilename),' line:',i,&
                               ' Can not read names of molecular types: NameNMol: ',l                               
                    stop                    
                endif
                
                do j=1, NMType
                    NameMType(j)=trim(adjustl(NameMType(j)))                    
                enddo
                write(stdout,*) 'MolecularType Names:'
                write(stdout,*) (trim(NameMType(j)), j=1,NMType)
                write(stdout,*) ''
            continue
!NMOLMTYPE (NSPEC)
        elseif ((uppercase(trim(adjustl(field)))=='NMOLMTYPE').or.(uppercase(trim(adjustl(field)))=='NSPEC')) then 
            allocate(NMolMType(NMType))
            allocate(NMolMTypeStr(NMType))
            call parse(l,',',NMolMTypeStr, iNMType)
                if (iNMType.ne.NMType) then
                    write(stdout,*) 'ERROR: Reading Input: File: ',trim(iFilename),' line:',i,&
                               ' Can not read Number of molecules: NMolMType: ',l                               
                        stop                    
                endif   
                do j=1, NMType
                    call str2value(trim(adjustl(NMolMTypestr(j))),NMolMType(j),ierr)
                    if (ierr.ne.0) then
                        write(stdout,*) 'ERROR: Reading Input: File: ',trim(iFilename),' line:',i,&
                               ' Can not read Number of molecules: NMolMType: ',l                               
                        stop                    
                    endif   
                enddo                
                write(stdout,*) 'Number of Molecules:',(NMolMType(1:NMType))
                write(stdout,*) ''
            continue
!LMoveMTYPE (LMOVE)
        elseif ((uppercase(trim(adjustl(field)))=='LMOVEMTYPE').or.(uppercase(trim(adjustl(field)))=='LMOVE')) then 
            allocate(LMoveMType(NMType))
            allocate(LMoveMTypeStr(NMType))
            call parse(l,',',LMoveMTypeStr, iNMType)
                if (iNMType.ne.NMType) then
                    write(stdout,*) 'ERROR: Reading Input: File: ',trim(iFilename),' line:',i,&
                    ' Can not read LMoveMType: ',l
                    stop 
                endif                
                do j=1, NMType
                    if ((uppercase(trim(adjustl(LMoveMTypeStr(j)))).eq.'.T.')&
                    .or.(uppercase(trim(adjustl(LMoveMTypeStr(j)))).eq.'T') &
                    .or.(uppercase(trim(adjustl(LMoveMTypeStr(j)))).eq.'TRUE') &
                    .or.(uppercase(trim(adjustl(LMoveMTypeStr(j)))).eq.'.TRUE.')) then                    
                        LMoveMType(j)=.true.
                    elseif ((uppercase(trim(adjustl(LMoveMTypeStr(j)))).eq.'.F.')&
                    .or.(uppercase(trim(adjustl(LMoveMTypeStr(j)))).eq.'F') &
                    .or.(uppercase(trim(adjustl(LMoveMTypeStr(j)))).eq.'FALSE') &
                    .or.(uppercase(trim(adjustl(LMoveMTypeStr(j)))).eq.'.FALSE.')) then                    
                        LMoveMType(j)=.false.
                    else                    
                        write(stdout,*) 'ERROR: Reading Input: File: ',trim(iFilename),' line:',i,&
                               ' Can not read LMoveMType: ',l                               
                        stop                    
                    endif   
                enddo          
                write(stdout,*) 'Molecules are free to move: ', LMOVEMType(1:NMType)
                write(stdout,*) ''
            continue

! Box (BOXL, BOYL, BOZL)            
            elseif ((uppercase(trim(adjustl(field)))=='BOX').or.(INDEX(uppercase(trim(adjustl(field))),'BO')==1)) then             
                write(stdout,*) 'BOX (A):',trim(l),':'
                write(stdout,*) ''
            select case (uppercase(trim(adjustl(field))))                
                case ('BOX')
                    ierr=size(box)
                    call parse(l,',',box, ierr)
                    if (ierr.ne.3) write(stdout,*) 'Error while reading Box size: line: ',l
!                    write(stdout,*) box
                    call str2value(box(1),BOXL,ierr)
                    call str2value(box(2),BOYL,ierr)
                    call str2value(box(3),BOZL,ierr)
                case ('BOXL')
                    call str2value(l,BOXL,ierr)
                case ('BOYL')
                    call str2value(l,BOYL,ierr)
                case ('BOZL')
                    call str2value(l,BOZL,ierr)
            end select
            if (ierr.ne.0) then
               write(stdout,*) 'ERROR: Reading Input: File: ',trim(iFilename),' line:',i,&
                       ' Can not read periodic box size: BOX ',l                               
                stop                    
            endif 
            continue                        
        endif
        i=i+1
    enddo
    
! Check if important values were set:
    if (.not. allocated(NMolMType)) then
        write(stdout,*) 'ERROR: Reading Input: File: ',trim(iFilename), 'Number of molecules of each kind NMolMType are not set'
        stop
    elseif (iPrint.ge.7) then 
        write(stdout,*) 'NMolMType=',NMolMType
    endif
    if (.not. allocated(NameMType)) then
        write(stdout,*) 'ERROR: Reading Input: File: ',trim(iFilename), 'Names of molecular types NameMType are not set'
        stop                        
    endif
    if (.not. allocated(LMoveMType)) then
        write(stdout,*) 'NOTE: Reading Input: File: ',trim(iFilename), &
        'All molecular types are allowed to move, since LMoveMType is not set. This is a default behaviour.'        
        allocate(LMoveMType(NMType))
        LMoveMType(:)=.true.
    endif

    if ((BOXL.le.0).or.(BOYL.le.0).or.(BOZL.le.0)) then
        write(stdout,*) 'ERROR: Reading Input: File: ',trim(iFilename), 'Periodic box size BOX is not set'
        stop                                           
    endif

    call ReadParameter(EPS, text, 'Epsilon', 'EPS',&             
        'Dielectric permittivity value',&
        'W',1.d0)

        
            
    call ReadParameter(TEMP, text, 'Temperature', 'TEMP',&             
        'Temperature',&
        'E',0.d0)

    call ReadParameter(NMKS, text, 'MCSteps', 'NMKS',&             
        'Number of MC steps',&
        'E',0)!

    call ReadParameter(NMKS0, text, 'MCStepsEquil', 'NMKS0',&             
        'Number of MC equilibration steps',&
        'E',0)
            
    call ReadParameter(DR, text, 'MCStepAtom', 'DR',&             
        'MC single atom displacement step',&
        'E',1.d0)    
        
    call ReadParameter(MCTRANSSTEP, text, 'MCStepTransMol', 'MCTRANSSTEP',&
        'MC molecule displacement step',&
        'N',0.d0)         
        
    call ReadParameter(ITRANS, text, 'iMCStepTransMol', 'ITRANS',&
        'MC molecule displacement frequency',&
        'N',0)            
    if ((MCTRANSSTEP.le.0).or.((ITRANS.le.0))) then
        write(stdout,*) 'WARNING: Reading Input: File: ',trim(iFilename), &
        'MC molecule displacement step (MCStepTransMol) or frequency (iMCStepTransMol) is not set.',&
         ' Molecule translation steps will not be performed in the simulation '
    endif    
    
    call ReadParameter(MCROTSTEP, text, 'MCStepRotMol', 'MCROTSTEP',&
        'MC molecule rotation step',&
        'N',0.d0)          
        ! Check if rotation is enabled and if MCROTSTEP is not too big
    if (((MCROTSTEP*2*3.1416).gt.0.3)) write((stdout),*) 'Warning: MC rotation angle is greater than 0.3.  SIN(PHI)!= phi'              

    call ReadParameter(IROT, text, 'iMCStepRotMol', 'IROT',&
        'MC molecule rotation frequency',&
        'N',0)              
    if ((MCROTSTEP.le.0).or.((IROT.le.0))) then
        write(stdout,*) 'WARNING: Reading Input: File: ',trim(iFilename), &
        'MC molecule rotation step (MCStepRotMol) or frequency (iMCStepRotMol) is not set.',&
         ' Molecule rotation steps will not be performed in the simulation '
    endif    

    call ReadParameter(IOUT, text, 'iCalcEnergy', 'IOUT',&
        'How often to recalculate total energy in MC',&
        'E',0)          


    call ReadParameter(RECUT, text, 'RCutEl', 'RECUT',&             
        'Cutoff distance for real space part of electrostatic interactions',&
        'E',0.d0)          

    call ReadParameter(AF, text, 'AF', 'AF',&             
        'Ewald electrostatics parameter AF',&
        'N',3.d0)          
            
    call ReadParameter(FQ, text, 'FQ', 'FQ',&             
        'Ewald electrostatics parameter FQ',&
        'N',9.d0)          

    call random_number(trand)
    call ReadParameter(NRS, text, 'RandomSeed', 'NRS',& 
        ' Random seed for the random number generator',&
        'W',int(trand*100))          

 ! Initializing random numbers generator
    do I=1,NRS+13*(stdout-6+1) ! Different initialization for each process
      W=rand()
      if(IPRINT.ge.10) write(stdout,*) I,W
    end do    
    if(IPRINT.ge.7)write(stdout,*) "Random seed: ",W
    
    call ReadParameter(POTCUT, text, 'ProhibPotLevel', 'POTCUT',& 
        ' Prohibiting potential level',&        
        'N',1000.d0)   

    call ReadParameter(IAV, text, 'iAverage', 'IAV',&            
        ' Averaging frequency Automatic value iAverage=NAtoms*2 will be used:',&        
        'W',-1)   
            
    call ReadParameter(REGP, text, 'REGP', 'REGP',&
        ' Regularization parameter (REGP) is not specified:',&
        'W',1.d0)          

    call ReadParameter(DPOTM, text, 'MaxPotCor', 'DPOTM',&
        'Maximum absolute correction of the potential',&
        'W',2.d0)              
    
!    call ReadParameter(LCRD, text, 'LoadStartingStructure', 'LCRD',&
!        'Trigger to load starting structure from file',&
!        'N',.False.)  
    call ReadParameter(LCRDPass, text, 'KeepStructure', 'LCRDPASS',&
        'Trigger to use final structure of previous iteration as starting structure for the next iteration',&
        'W',.False.)  

    call ReadParameterReal(RTM, text, 'MaxRelDif', 'RTM',&
        'Parameter limiting maximum relative difference between reference and resulting averages',&
        'N',10.d0)  
        
    call ReadParameter(IREPT, text, 'NIter', 'IREPT',&
        'Numer of inverse iterations to perform',&
        'E',1)  
        
    call ReadParameter(LIMC, text, 'UseIMC', 'LIMC',&
        'Trigger to use Inverse Monte Carlo (or IBI instead)',&
        'W',.True.)  
        
!    call ReadParameter(LZeroPot, text, 'InitPotZero', 'LZEROPOT',&
!        'Trigger to initialize NB-potentials with zeros',&
!        'N',.False.)  
    call ReadParameter(IPotCorrCheck, text, 'iPotCorCheck', 'iPotCorrCheck',&
        'How often to perform intermediate potential correction checks?',&
        'N',0)  
    LPotCorrCheck=.false.
    if (IPotCorrCheck.gt.0) then 
        LPotCorrCheck=.true. ! If potential correction convergence test is enabled           
        PotCorrCheckLevel=0.1
    endif

!    call ReadParameter(NA, text, 'NPointsNB', 'NA',&
!        'Number of points in intermolecular RDF/potential',&
!        'E',0)  
    
    call ReadParameter(LEV, text, 'EigVec', 'LEV',&
        'Trigger to calculate eigen vector for cross-corelation matrix',&
        'N',.false.)   
                
    call ReadParameter(FilRDF, text, 'InputRDF', 'FILRDF',&
        'Input RDF file',&
        'W','')  
        if (FilRDF=='') then
            write(stdout,*) ''
            write(stdout,*) 'ATTENTION!!! No RDF-file provided -> Inverse calculation can not be performed'
            write(stdout,*) ''
            LRDF=.false.
        else 
            LRDF=.true.
        endif
        
    call ReadParameter(FilPot, text, 'InputPot', 'FILPOT',&
        'Input Potential file',&
        'W','')  
    if (FilPOT=='') then   
        write(stdout,*) ''
        write(stdout,*) 'ATTENTION!!! No potential-file provided -> Potentials will be initialized from RDF-data'
        write(stdout,*) ''
        LPOT=.false.
    else
        LPOT=.true.
    endif
    
    call ReadParameter(FSTART, text, 'InputStartCoords', 'FSTART',&
        'Input file with starting coordinates',&
        'W','')  
    if (FSTART=='') then            
        write(stdout,*) 'NOTE! No starting coordinate-files are provided -> The starting structure will be generated randomly'
        LCRD=.false.
    else
        write(stdout,*) 'Starting coordinates will be read from file ',trim(FSTART)
        LCRD=.true.
    endif
        
    call ReadParameter(FCRD, text, 'InputFrozenCoords', 'FCRD',&
        'File with coordinates of frozen molecules',&
        'N','')  
        
    call ReadParameter(LXMOL, text, 'DumpLastConf', 'LXMOL',&
        'Trigger to save last configuration of each MC-simulation',&
        'N',.false.)  
        
    call ReadParameter(ITR, text, 'WriteTraj', 'ITR',&
        'How often to write configurations to the trajectory',&
        'N',0)
        if (ITR==0) then
            write(stdout,*) 'NOTE! The trajectory will not be written'
        endif
        

 ! Some extra checks moved here from molsim.f-main()
    if(.not.(LRDF.or.LPOT))then
       write(stdout,*)' Either LRDF or LPOT must be set to .true.!!! '
       stop
    end if
    
#ifdef PBC_TO
    if (RECUT.gt.min(BOXL,BOYL,BOZL)*sqrt(3.0)/4.0) then
       write(stdout,*)' Real space electrostatics cutoff radius is larger than half of the smallest box size!'
       stop
    endif
#else
    if (RECUT.gt.min(BOXL,BOYL,BOZL)*0.5) then
       write(stdout,*)' Real space electrostatics cutoff radius is larger than half of the smallest box size!'
       stop
    endif
#endif    
!write(*,*) 'DEBUG readinput', NameMType(:)
 write(stdout,*) 'Main input file parsed successfully.'     
end subroutine ReadInput

subroutine ReadParameterInt(param,text, name, oldname, message, etype, defval)
    integer(4) param, defval
    character(input_text), allocatable:: text(:)    
    character(len=*) name, oldname
    character(len=*) message
    character etype    
    ! Local variables    
    integer i, ierr
    character(input_text) field, l, str    
    logical readed
    character(len=256) msg
    
    readed=.false.     ! Set not readed:
    !loop over the text 
    !write(*,*) 'DEBUG ReadParameterInt: size(text)',size(text)
    do i=1, size(text)
        call ReadLineFromText(text,i,str,ierr)
        if (ierr.ne.0) exit
        l=str
    !    write(*,*) 'DEBUG ReadParameterInt:',name,':',l,':'
        call split(l,'=',field)
    !    write(*,*) 'DEBUG ReadParameterInt:',name,':',l,':',field,':'
        if ((uppercase(trim(adjustl(field)))==uppercase(trim(adjustl(name))))&
        .or.(uppercase(trim(adjustl(field)))==uppercase(trim(adjustl(oldname))))) then
            call str2value(trim(adjustl(l)),param,ierr)
            if (ierr.ne.0) then
                write(stdout,*) 'ERROR: Reading Input: line:',i,&
                ' Can not read the ',trim(message),' : (',trim(adjustl(name)),'):',l
                write(stdout,*) str
                stop                
            endif
            readed=.true.
            exit
            
        endif
    enddo
    ! Check if value was set:
    write(msg,*) trim(message),' (',trim(adjustl(name)),') is not specified:'
    if (.not.readed) then
        select case (uppercase(etype))
            case('E')
                write(stdout,*) 'ERROR: Reading Input: ', trim(msg)                
                stop
            case('W')
                write(stdout,*) 'WARNING: Reading Input: ',trim(msg)
                write(stdout,*) 'Default value of ',defval, ' will be used'
                param=defval
            case('N')
                write(stdout,*) 'NOTE: Reading Input: ',trim(msg)
                write(stdout,*) 'Default value of ',defval, ' will be used'
                param=defval    
        end select
    endif
    if (iPrint .ge.7) write(stdout,*) trim(adjustl(name)),'=',param
end subroutine ReadParameterInt
    
subroutine ReadParameterInt8(param,text, name, oldname, message, etype, defval)
    integer(8) param
    integer(4) defval
    character(input_text), allocatable:: text(:)    
    character(len=*) name, oldname
    character(len=*) message
    character etype    
    ! Local variables    
    integer i, ierr
    character(input_text) field, l, str    
    logical readed
    character(len=256) msg
    
    readed=.false.     ! Set not readed:
    !loop over the text 
    do i=1, size(text)
        call ReadLineFromText(text,i,str,ierr)
        if (ierr.ne.0) exit
        l=str
        call split(l,'=',field)
        
        if ((uppercase(trim(adjustl(field)))==uppercase(trim(adjustl(name))))&
        .or.(uppercase(trim(adjustl(field)))==uppercase(trim(adjustl(oldname))))) then
            call str2value(trim(adjustl(l)),param,ierr)
            if (ierr.ne.0) then
                write(stdout,*) 'ERROR: Reading Input: line:',i,&
                ' Can not read the ',trim(message),' : (',trim(adjustl(name)),'):',l
                write(stdout,*) str
                stop                
            endif
            readed=.true.
            exit
            
        endif
    enddo
    ! Check if value was set:
    write(msg,*) trim(message),' (',trim(adjustl(name)),') is not specified:'
    if (.not.readed) then
        select case (uppercase(etype))
            case('E')
                write(stdout,*) 'ERROR: Reading Input: ', trim(msg)                
                stop
            case('W')
                write(stdout,*) 'WARNING: Reading Input: ',trim(msg)
                write(stdout,*) 'Default value of ',defval, ' will be used'
                param=defval
            case('N')
                write(stdout,*) 'NOTE: Reading Input: ',trim(msg)
                write(stdout,*) 'Default value of ',defval, ' will be used'
                param=defval    
        end select
    endif
    if (iPrint .ge.7) write(stdout,*) trim(adjustl(name)),'=',param
end subroutine ReadParameterInt8
    
subroutine ReadParameterReal(param,text, name, oldname, message, etype, defval)
    real(8) param, defval
    character(input_text), allocatable:: text(:)    
    character(len=*) name, oldname
    character(len=*) message
    character etype    
    ! Local variables    
    integer i, ierr
    character(input_text) field, l, str   
    character(len=256) msg
    logical readed
    
    readed=.false.     ! Set not readed:
!loop over the text 
    do i=1, size(text)
        call ReadLineFromText(text,i,str,ierr)
        if (ierr.ne.0) exit
        l=str
        call split(l,'=',field)
        
        if ((uppercase(trim(adjustl(field)))==uppercase(trim(adjustl(name))))&
        .or.(uppercase(trim(adjustl(field)))==uppercase(trim(adjustl(oldname))))) then
            call str2value(trim(adjustl(l)),param,ierr)
            if (ierr.ne.0) then
                write(stdout,*) 'ERROR: Reading Input: line:',i,&
                ' Can not read the ',trim(message),' : (',trim(adjustl(name)),'):',l
                write(stdout,*) str
                stop                
            endif
            readed=.true.
            exit
        endif
    enddo
    ! Check if value was set:
    write(msg,*) trim(message),' (',trim(adjustl(name)),') is not specified:'
   if (.not.readed) then
        select case (uppercase(etype))
            case('E')
                write(stdout,*) 'ERROR: Reading Input: ', trim(msg)                
                stop
            case('W')
                write(stdout,*) 'WARNING: Reading Input: ',trim(msg)
                write(stdout,*) 'Default value of ',defval, ' will be used'
                param=defval
            case('N')
                write(stdout,*) 'NOTE: Reading Input: ',trim(msg)
                write(stdout,*) 'Default value of ',defval, ' will be used'
                param=defval    
        end select
    endif
    if (iPrint .ge.7) write(stdout,*) trim(adjustl(name)),'=',param
end subroutine ReadParameterReal

subroutine ReadParameterString(param,text, name, oldname, message, etype, defval)
    character(len=*) param, defval
    character(input_text), allocatable:: text(:)    
    character(len=*) name, oldname
    character(len=*) message    
    character etype    
   ! Local variables    
    integer i, ierr
    character(input_text) field, l, str    
    logical readed
    character(len=256) msg
    
    readed=.false.     ! Set not readed:   
    !loop over the text 
    do i=1, size(text)
        call ReadLineFromText(text,i,str,ierr)
        if (ierr.ne.0) exit
        l=str
        call split(l,'=',field)
        
        if ((uppercase(trim(adjustl(field)))==uppercase(trim(adjustl(name))))&
        .or.(uppercase(trim(adjustl(field)))==uppercase(trim(adjustl(oldname))))) then
            ! Clean l from possible begin and end symbols like ' and "
                call delall(l,'"')
                call delall(l,"'")
            param=trim(adjustl(l))
!            if (ierr.ne.0) then
!                write(stdout,*) 'ERROR: Reading Input: line:',i,&
!                ' Can not read the ',trim(message),' : (',trim(adjustl(name)),'):',l
!                write(stdout,*) str
!                stop                
!            endif
            readed=.true.
            exit
        endif
    enddo
    ! Check if value was set:
    write(msg,*) trim(message),' (',trim(adjustl(name)),') is not specified:'
    if (.not.readed) then
        select case (uppercase(etype))
            case('E')
                write(stdout,*) 'ERROR: Reading Input: ', trim(msg)                
                stop
            case('W')
                write(stdout,*) 'WARNING: Reading Input: ',trim(msg)
                write(stdout,*) 'Default value of ',defval, ' will be used'
                param=defval
            case('N')
                write(stdout,*) 'NOTE: Reading Input: ',trim(msg)
                write(stdout,*) 'Default value of ',defval, ' will be used'
                param=defval      
        end select
    endif
    if (iPrint .ge.7) write(stdout,*) trim(adjustl(name)),'=',trim(adjustl(param))
end subroutine ReadParameterString
    
subroutine ReadParameterLogical(param,text, name, oldname, message, etype, defval)
    logical param, defval
    character(input_text), allocatable:: text(:)    
    character(len=*) name, oldname
    character(len=*) message    
    character etype    
    ! Local variables
    character(len=256) msg
    logical readed
    integer i, ierr
    character(input_text) field, l, str    
    ! Set impossible defaults:
    readed=.false.
    !loop over the text 
!    if (iPrint.ge.7) write(stdout,*) 'Reading parameter ',name,' from text-array of length ',size(text)
    do i=1, size(text)
!        write(*,*) 'DEBUG:',str,':',i
        call ReadLineFromText(text,i,str,ierr)
        if (ierr.ne.0) exit
!        write(*,*) 'DEBUG:',str,':',i
        l=str
        call split(l,'=',field)
!        write(*,*) 'DEBUG:',field,':',str,':'
        if ((uppercase(trim(adjustl(field)))==uppercase(trim(adjustl(name))))&
            .or.(uppercase(trim(adjustl(field)))==uppercase(trim(adjustl(oldname))))) then
        
            if ((uppercase(trim(adjustl(l))).eq.'.T.')&
            .or.(uppercase(trim(adjustl(l))).eq.'TRUE')&
            .or.(uppercase(trim(adjustl(l))).eq.'.TRUE.')) then
                param=.true.
            elseif ((uppercase(trim(adjustl(l))).eq.'.F.')&
            .or.(uppercase(trim(adjustl(l))).eq.'FALSE')&
            .or.(uppercase(trim(adjustl(l))).eq.'.FALSE.')) then
                param=.false.
            else
                write(stdout,*) 'ERROR: Reading Input:',&
                    ' Can not read the ',trim(message),' : (',trim(adjustl(name)),'):'
                write(stdout,*) 'line:"',str,'"'
                stop                
            endif
            readed=.true.
            exit
         endif        
    enddo  
    ! Check if value was set:
    write(msg,*) trim(message),' (',trim(adjustl(name)),') is not specified:'
    if (.not.readed) then
        select case (uppercase(etype))
            case('E')
                write(stdout,*) 'ERROR: Reading Input: ', trim(msg)                
                stop
            case('W')
                write(stdout,*) 'WARNING: Reading Input: ',trim(msg)
                write(stdout,*) 'Default value of ',defval, ' will be used'
                param=defval
            case('N')
                write(stdout,*) 'NOTE: Reading Input: ',trim(msg)
                write(stdout,*) 'Default value of ',defval, ' will be used'
                param=defval       
        end select
    endif
        if (iPrint .ge.7) write(stdout,*) trim(adjustl(name)),'=',param
end subroutine ReadParameterLogical
