!     
! File:   potreadpropcommon.f90
! Author: sasha
!
! Created on December 16, 2013, 1:47 PM
!
module mcmio   
    use precision
    use strings
    use utilsmod
    use dynarray       
    implicit none

    integer, private :: iPrint, stdout
        
    contains
    include "mcmio_setreferences.f90"
! Read list of sites/atoms in every MoleclarType (mcm-file) and create a global list of their properties.
    include "mcmio_readsites.f90"
    include "mcmio_readbond.f90"
    include "mcmio_stypedetect.f90"
    include "mcmio_setcomzero.f90"
    include "initiate.f90"
subroutine ReadMCM(NMType, NameMType,&
    NSiteMType, NBondMType, SumMassMType,&
    NSite, NameSite, IndexSTypeSite, MTypeSite, RSite, MassSite,ChargeSite,  &
    NSType, MTypeSType, NameSType,&    
    NBond, NBondB, NBondA, Bond_iSjS, i_SiteInBond, j_SiteInBond, k_SiteInBond, NSiteGroupsInBond, BTypeBond,MTypeBond)
    use strings
    use precision
    implicit none    
    
    integer, allocatable:: NSiteMType(:),NBondMType(:)
    character(filename_text),allocatable:: NameMType(:)
    real(8), allocatable :: SumMassMType(:)

    integer NSite,NSType,NMType
    integer, allocatable:: IndexSTypeSite(:),MTypeSite(:), MTypeSType(:)
    character(atom_name_len), allocatable:: NameSite(:), NameSTypeSite(:), NameSType(:)
    integer, allocatable::Bond_iSjS(:,:), i_SiteInBond(:,:), j_SiteInBond(:,:), k_SiteInBond(:,:), NSiteGroupsInBond(:),&
        BTypeBond(:),MTypeBond(:)
    integer NBond,NBondB, NBondA
    real(8), allocatable:: RSite(:,:)                       
    real(8), allocatable:: MassSite(:), ChargeSite(:)
    
    ! Read list of sites from each mcm-file. Create global list of sites, Name, X,Y,Z, Mass, Charge, TypeIndex, TypeName
!    write(*,*) 'DEBUG readmcm', NameMType(:)
    call MCMioReadSites(NMType, NameMType, NSiteMType, SumMassMType,&
    NSite, NameSite, RSite, MassSite, ChargeSite, IndexSTypeSite, NameSTypeSite,MTypeSite,&
    IPrint, stdout)
    ! Analyze list of site-types based on their names
     write(stdout,*) ''     
    call MCMioSTypeDetect(NSite,NameSite,NameSTypeSite,IndexSTypeSite,MTypeSite,&
         MTypeSType, NSType, NameSType, iPrint,stdout) 
    call MCMioReadBond(NMType, NameMType, NSiteMType, NBond, NBondB, NBondA, BTypeBond, MTypeBond, NBondMType,&
        Bond_iSjS, i_SiteInBond, j_SiteInBond, k_SiteInBond, NSiteGroupsInBond, iPrint, stdout)
            
        write(stdout,*) 'MCM-files are read successfully.'
        write(stdout,*) ''
        write(stdout,*) 'Number of Site/Atom types detected:',NSType
        write(stdout,*) 'Number of Sites detected:',NSite
        write(stdout,*) 'Number of intramolecular bonds detected:',NBond
end subroutine ReadMCM
        
subroutine mcmSetStdOut(stdout_, iPrint_)
        integer stdout_, iPrint_
        stdout=stdout_
        iPrint=iPrint_
end subroutine                
end