subroutine MCMioSTypeDetect(NSite,NameSite,NameSTypeSite,IndexSTypeSite,MTypeSite,&
             MTypeSType, NSType, NameSType, &
            iPrint,stdout)
    ! GLobal variables
    character(atom_name_len), allocatable:: NameSTypeSite(:),NameSType(:),NameSite(:)
    integer, allocatable::IndexSType(:), IndexSTypebyNameSite(:),IndexSTypeSite(:),IndexSTypeByIndexSite(:),MTypeSite(:),&
                        MTypeSType(:)!,NSiteSType(:)
    integer NSite, NSType
    integer iPrint, stdout
    ! Local variables
    logical flag
    integer iNSite, ISType, IndexiSite
    integer NSTypeByName,NSTypeByIndex
    character(atom_name_len) NameISite,FMT
    
    write(stdout,*) 'Detecting unique site (atom) types present in the system'    
    call reshape(IndexSTypeByNameSite,NSite)
    call reshape(IndexSTypeByIndexSite,NSite)
    NSType=0 ! Number of site types registered    
    do iNsite=1, NSite
        flag=.false.
        NameiSite=NameSTypeSite(iNSite)
        do iSType=1, NSType
            if (NameiSite==NameSType(iSType)) then
                IndexSTypeByNameSite(iNSite)=iSType
                flag=.true.
                exit
            endif
        enddo
        if (.not.flag) then ! Registering new site type
            NSType=NSType+1
            call reshape(NameSType,NSType)
            NameSType(NSType)=NameiSite
            IndexSTypebyNameSite(iNSite)=NSType
            if (iPrint.ge.5) &
                write(stdout,*) '  Reading MCM-file: New SiteType name detected: ',NameSType(NSType), ' index: ',NSType
        endif
    enddo
    
    ! Now detect site types by index
    NSTypeByIndex=0 ! Number of site types registered    
    do iNsite=1, NSite
        flag=.false.
        IndexiSite=IndexSTypeSite(iNSite)
        do iSType=1, NSTypeByIndex
            if (IndexiSite==IndexSType(iSType)) then
                IndexSTypeByIndexSite(iNSite)=iSType
                flag=.true.
                exit
            endif
        enddo
        if (.not.flag) then ! Registering new site type
            NSTypeByIndex=NSTypeByIndex+1
            call reshape(IndexSType,NSTypeByIndex)
            IndexSType(NSTypeByIndex)=IndexiSite
            IndexSTypebyIndexSite(iNSite)=NSTypeByIndex
            if (iPrint.gt.5) &
              write(stdout,*) '  Reading MCM-file: New SiteType number detected: ',IndexSType(NSTypeByIndex), &
              ' index: ',NSTypeByIndex
        endif
    enddo
    
    ! Check if the site order by type name is in agreement with type number stated in mcm-file
    do iNsite=1, NSite
        if (IndexSTypeByNameSite(iNSite).ne.IndexSTypeSite(iNSite)) then
            write(stdout,*) 'ERROR: Reading MCM-file: Problem with site ',trim(NameSite(iNSite)), ' number ',iNSite 
            write(stdout,*) 'Number of molecular type the site belongs to (if ordered by name):',IndexSTypeByNameSite(iNSite),&
            ' does not correspond to stated site type number:',IndexSTypeSite(iNSite)
            write(stdout,*) 'Please check your mcm-file carefully' 
            stop
        endif
    enddo

    write(stdout,*) ''
    write(stdout,*) 'Please check if sites sorted by name of site type are in agreement with sites sorted by site type index'
    ! Check if sites order by type name and type index have exactly the same order, to detect user input errors.    
    do iNsite=1, NSite
        if (IndexSTypeByNameSite(iNSite).ne.IndexSTypeByIndexSite(iNSite)) then
            write(stdout,*) 'ERROR: Reading MCM-file: Problem with site ',NameSite(iNSite), ' number ',iNSite 
            write(stdout,*) 'Name of the site type:',NameSTypeSite(iNSite),' does not correspond to stated site type number:'&
            ,IndexSTypeSite(iNSite)
            write(stdout,*) 'Please check your mcm-file carefully' 
            stop
        endif
    enddo
    
!    write(stdout,*) ''
!    write(stdout,*) 'Please check if sites sorted by name of site type are in agreement with'
!    write(stdout,*) 'sites sorted by site type index'
    do iSType=1, NSType
!        write(stdout,*) atom_name_len
        write(FMT,'(i3)') atom_name_len+1
        write(stdout,'(a18,a'//trim(FMT)//',a1)',advance='no') '   Sites of type ',NameSType(iSType),':'        
        do iNsite=1, NSite
            if (IndexSTypeByNameSite(iNSite).eq.iSType) write(stdout,'(a'//FMT//')',advance='no') NameSite(iNSite)            
        enddo
        write(stdout,*) ''
        write(stdout,'(a18,i3,a3)',advance='no') '   Sites of type ',IndexSType(iSType),'  :'        
        do iNsite=1, NSite
            if (IndexSTypeByIndexSite(iNSite).eq.iSType) write(stdout,'(a'//FMT//')',advance='no') NameSite(iNSite)            
        enddo
        write(stdout,*) ''
    enddo
    
    call reshape(MTypeSType, NSite)
!    call reshape(NSiteSType, NSite)
    do iNSite=1, NSite
        MTypeSType(IndexSTypeSite(iNSite))=MTypeSite(iNSite)
!        NSiteSType(IndexSTypeSite(iNSite))=NSiteSType(IndexSTypeSite(iNSite))+1
    enddo

end subroutine

