!     
! File:   potreadpropcommon.f90
! Author: sasha
!
! Created on December 16, 2013, 1:47 PM
!
module potio   
    use precision
    use strings
    use utilsmod
    use dynarray
    implicit none

    integer, private:: iPrint, stdout

    contains
    include "potio_potreadpropa.f90"
    include "potio_potreadpropb.f90"
    include "potio_potreadpropcommon.f90"
    include "potio_potreadpropnb.f90"
    include "potio_potreadtablecommon.f90"
    include "potio_readgeneralsection.f90"
    include "potio_readincludepotentialsection.f90"
    include "potio_readpot.f90"
    include "potio_writepot.f90"

!    subroutine ReadLineFromText(text,i,line,IE)
!    ! the subroutine reads 
!    character(pot_text) line
!    integer IE,i
!    character(pot_text), allocatable:: text(:)
!    
!    line=''
!    IE=0  
!!    write(*,*) 'DEBUGG', i, text(i)
!    do  while (i.le.size(text))
!        if (i.gt.size(text)) then
!            write(*,*) 'ERROR: ReadLineFromText: Trying to read line number ',i,' from a text-array with size ',size(text)
!            ie=1
!            return
!        endif
!        line=TRIM(ADJUSTL(text(i)))
!        if ((line(1:1).ne.'#').and.(line(1:1).ne.'!')) then ! The line is not comment
!            return
!        else ! Read the next line
!            i=i+1
!        endif
!    enddo
!    ie=1
!    line=''
!    return
!end subroutine
subroutine GetPotFileLength(iFilename,iend)
    character(filename_text) iFilename 
    character(pot_text) l
    integer i, ierr, iend, iostt
    ! Open the potential file and scan it  for number of lines (variable iend)
    open(unit=4,file=iFilename,status='old',iostat=iostt)
    if (iostt .ne. 0) then
        write(stdout,*)'ERROR: Potential input file ',iFilename,' is not found!'
	stop
    endif
    i=0
    iend=0
    ierr=0
    do 
        read(4,'(a)',end=99) l
        iend=iend+1        
        cycle ! read next line
99      ierr=1 ! Return error flag when end of file
        if (ierr==1) then
            write(stdout,*) 'End of the potential input file reached.',iend,' lines read.'
            exit
        endif
    enddo
    close(4)    
end subroutine

subroutine GetEndOfPotentialSection(text,i,iend,bPotential,ePotential)
! Global variables
    integer i, bPotential, ePotential,iend
    character(pot_text), allocatable :: text(:)

! Local variables
    integer j, ierr
    character(pot_text) str,l
    
!    write(*,*) 'Debug: Found &Potential line:',i
    bPotential=i
    j=bPotential+1
    do j=bPotential+1,iend ! Search for &EndPotential
        call ReadLineFromText(text,j,l,ierr)
        if (uppercase(trim(l))=='&ENDPOTENTIAL') then 
!            write(*,*) 'Debug: Found &EndPotential line:',j
            ePotential=j
            exit
        elseif ((uppercase(trim(l))=='&POTENTIAL').or.(j.eq.iend)) then
!            write(*,*) 'ERROR: Reading Potential: Can not find end of the section &Potential started at line ',bPotential 
            stop 
        endif
    enddo
end subroutine

subroutine potioSetStdOut(stdout_, iPrint_)
        integer stdout_, iPrint_
        stdout=stdout_
        iPrint=iPrint_
end subroutine                
end