subroutine PotReadPropCommon(text, bPotential, ePotential, PName, PRmin, PRmax, PNPoints, PType,&
                            cnt_N_NB, cnt_N_B, cnt_N_A, bTable, eTable,FlagFixed, FlagZero, &
                            FlagTableFound, FlagIncludeFileFound, IncludeFileName)
! Global Variables
    character(pot_text), allocatable :: text(:)
    character(pot_text) PName,PType, IncludeFileName
    integer bPotential, ePotential, PNPoints, bTable, eTable,cnt_N_NB, cnt_N_B, cnt_N_A
    real(8) PRmin, PRmax
    logical FlagFixed, FlagZero,FlagTableFound, FlagIncludeFileFound
! Local Variables
    integer  cnt_bTable, cnt_eTable, &
    j,ierr
    character(pot_text) str,l,field
    
    bTable=0
    eTable=0
    cnt_eTable=0
    cnt_bTable=0
    ! By default, each potential is not fixed and not zero
    FlagFixed=.false. 
    FlagZero=.false.
    FlagTableFound=.false.
    FlagIncludeFileFound=.false.
    do j=bPotential, ePotential
        call ReadLineFromText(text,j,str,ierr)
        l=str
        call split(l,'=',field)        
        select case (uppercase(trim(adjustl(field))))
            case ('NAME')
                PName=trim(adjustl(l))
!                       write(stdout,*) 'Debug: Name:',Pname
            case ('MIN')
                call str2value(trim(adjustl(l)),PRMIN,ierr)
                if (ierr.ne.0) then
                    write(stdout,*) 'ERROR: Reading Potential: line:',j,' Can not read the actual value of MIN:',l
                    write(stdout,*) str
                    stop                                                                                                    
                endif
!                      write(stdout,*) 'Debug: RMIN:',Prmin
            case ('MAX')
                call str2value(trim(adjustl(l)),PRMAX,ierr)
                if (ierr.ne.0) then
                    write(stdout,*) 'ERROR: Reading Potential: line:',j,' Can not read the actual value of MAX:',l
                    write(stdout,*) str
                    stop                                                                      
                endif
!                       write(stdout,*) 'Debug: RMAX:',Prmax
            case ('NPOINTS')
                call str2value(trim(adjustl(l)),PNPoints,ierr)
                if (ierr.ne.0) then
                    write(stdout,*) 'ERROR: Reading Potential: line:',j,' Can not read the actual value of NPoints:',l
                    write(stdout,*) str
                    stop                
                endif
            case ('TYPE')
                PType=trim(adjustl(l))
!                write(stdout,*) 'Debug Type=',PType
                select case (trim(adjustl(PType)))
                    case ('NB')
                        cnt_N_NB=cnt_N_NB+1
                    case ('B')
                        cnt_N_B=cnt_N_B+1
                    case ('A')
                        cnt_N_A=cnt_N_A+1
                    case default
                        write(stdout,*) 'Error: line ',j,': Wrong type of the potential:',&
                                    trim(adjustl(PType)),'    It shall be NB, B or A'                                
                end select 
!                        write(stdout,*) 'Debug: NPOINTS:',PNPOINTS
             case ('&TABLE')
                   FlagTableFound=.true.
                   bTable=j
                   cnt_bTable=cnt_bTable+1
            case ('&ENDTABLE')
                   eTable=j
                   cnt_eTable=cnt_eTable+1                        
            case ('&FIXED')
                   FlagFixed=.true.
            case ('&ZERO')
                   FlagZero=.true.
            case ('&INCLUDEPOTENTIAL')
                   FlagIncludeFileFound=.true.
                   IncludeFileName=trim(adjustl(l))
                   write(stdout,*) 'Debug: IncludedFileFound:', IncludeFileName                   
            case default
                 continue
!                write(stdout,*) 'Debug: Unknown line:',trim(adjustl(str))
        end select                                
    enddo
    ! Check consistency of &Table &EndTable tags
    if (.not. FlagIncludeFileFound) then
        if  ((cnt_bTable.gt.1) .or. (cnt_eTable.gt.1)) then
            write(stdout,*) 'ERROR: Reading Potential: more than one line with tag &Table or &EndTable found '
            stop
        endif    
        if (bTable.eq.0) then
            write(stdout,*) 'ERROR: Reading Potential: Can not find begin of section &Table'
            stop
        endif
        if (eTable.eq.0) then
            write(stdout,*) 'ERROR: Reading Potential: Can not find end of section &EndTable'
            stop 
        endif
        if (bTable.gt.eTable) then
            write(stdout,*) 'ERROR: Reading Potential: The section &Table starts at line ',bTable, 'and ends at line ',eTable
            stop
        endif
        if (FlagTableFound .and. FlagIncludeFileFound) then
            write(stdout,*) 'ERROR: Reading Potential: Both &Table and &IncludePotential are present in the potential definition.'
            stop
        endif
    endif
    if (.not.(FlagTableFound .or. FlagIncludeFileFound .or. FlagZero)) then
        write(stdout,*) 'ERROR: Reading Potential: Neither &Table nor &IncludePotential nor &Zero are found', &
                    'The potential values are not defined.'
        stop
    endif

end subroutine