subroutine ReadPot(iFilename, NameMType, NBondMType,AdrSiteMType,NSType, NameSType,&! NA,&
    StateNB_iSjS,StateB_iBond, PotB_riBond, rPotB_riBond,PotNB_riSjS, Bond_iSjS, & 
    NSiteGroupsInBond, i_SiteInBond, j_SiteInBond, k_SiteInBond,&
    NPoints, RMax, RMin,&
    NPointsPotB,RMaxPotB,RMinPotB)
    
    
    use strings
    use precision
    implicit none

! Global variables    
    character(filename_text) iFilename
    integer, allocatable:: NPointsPotB(:)
    real(8), allocatable:: RMaxPotB(:),RMinPotB(:)
    integer N_NB, N_B, N_A, NPoints,PNpoints, AtomTypesPair(2), NSType!, NA
    integer, allocatable:: StateNB_iSjS(:,:), StateB_iBond(:),Bond_iSjS(:,:),&
            NBondMType(:), AdrSiteMType(:)
    real(8), allocatable:: PotNB_riSjS(:,:,:), PotB_riBond(:,:), rPotB_riBond(:,:)
    real(8) RMax, RMin
          
    character(atom_name_len), allocatable:: NameSType(:) 
    character(atom_name_len) AtomTypesPairStr(2)
    character(filename_text) NameMType(:)
    integer, allocatable :: NSiteGroupsInBond(:), i_SiteInBond(:,:), j_SiteInBond(:,:), k_SiteInBond(:,:)
! Local variables
    real(8)   PRmax,PRmin, tmp_r, tmp_U    
    real(8), allocatable:: r(:), U(:)
    character(pot_text), allocatable :: text(:),pottext(:) 
    character(pot_text) l,str,field,Ptype,pname
    character(filename_text) PotFileName
    integer i,j,k, ierr, iend, iostt, bGeneral, eGeneral, cnt_bGeneral, cnt_eGeneral,&
            bPotential,ePotential, cnt_N_NB, cnt_N_B, cnt_N_A, &            
            bTable, eTable, &!, cnt_bTable, cnt_eTable
            PNPairs,PNTriplets, &
            iend_pot_text, bPotential_text, ePotential_text, bTable_text, eTable_text,&
            MolType, iBond, iPoint, NBonds
    integer, allocatable:: AtomPairs(:,:), AtomTriplets(:,:)
    logical FlagTableFound, FlagIncludeFileFound, FlagZero, FlagFixed

! Open the potential file and scan it  for number of lines (variable iend)
    call GetPotFileLength(iFilename,iend)
! Allocate array for the file    
    allocate(text(iend),pottext(iend))
! Read the file to the array text
    open(unit=4,file=iFilename,status='old',iostat=iostt)
    do i=1,iend
        read(4,'(a)') l
        text(i)=trim(adjustl(l))
!        write(stdout,*) text(i)
    enddo
    close(4)
!    write(stdout,*) 'Debug: iend=',iend
!Read &General section of the file
    call ReadGeneralSection(text, iend, N_NB, N_B, N_A, NPoints, RMax, RMin, eGeneral)
    if (.not. allocated(PotNB_riSjS)) allocate(PotNB_riSjS(NPoints,NSType,NSType))    
!    if (NPoints.ne.NA) then
!        write(stdout,*) 'ERROR: Reading Potentials:'
!        write(stdout,*) 'Number of points stated in general section of potential-file: NPoints=', NPoints, 'differs from'
!        write(stdout,*) 'number of points stated in main input file : NA=', NA
!        stop
!    endif
! Read Potentials
    NBonds=sum(NBondMType(:))
    ! Count the actual number of Non-bonded, bonded, and bending angle potentials
    i=eGeneral+1 
    bPotential=0
    ePotential=0
    cnt_N_NB=0
    cnt_N_B=0
    cnt_N_A=0    
    do while (i.le.iend)
        call ReadLineFromText(text,i,l,ierr)
        ! Indicate presence of &Potential 
        if(uppercase(trim(l))=='&POTENTIAL') then ! Found begin of the potential-section
            ! Find end of the potential section
            call GetEndOfPotentialSection(text,i,iend,bPotential,ePotential)
            ! Read common properties of the potential
            call PotReadPropCommon(text, bPotential, ePotential, PName, PRmin, PRmax, PNPoints, PType,&
                            cnt_N_NB, cnt_N_B, cnt_N_A, bTable, eTable, FlagFixed, FlagZero,&
                            FlagTableFound, FlagIncludeFileFound, PotFileName)
            if (FlagIncludeFileFound) then
               call ReadIncludedPotentialSection(PotFileName, pottext, iend_pot_text, bPotential_text, ePotential_text, &
                        bTable_text, eTable_text)                
            else
                potFileName=iFileName
                pottext=text
                iend_pot_text=iend
                bPotential_text=bPotential
                ePotential_text=ePotential
                bTable_text=bTable
                eTable_text=eTable
            endif 
            ! Read specific properties of the potential with respect to the type
            select case (trim(adjustl(PType)))
                case ('NB')
                    call PotReadPropNB(pottext, potFileName, bPotential_text, ePotential_text, &
                        NameSType, AtomTypesPairStr, AtomTypesPair, &
                        Rmin, RMax, PRmin, PRmax, Npoints, PNpoints)
                    StateNB_iSjS(AtomTypesPair(1),AtomTypesPair(2))=IBSet(StateNB_iSjS(AtomTypesPair(1),AtomTypesPair(2)),3)                                             
                    if (FlagFixed) &
                        StateNB_iSjS(AtomTypesPair(1),AtomTypesPair(2))=IBSet(StateNB_iSjS(AtomTypesPair(1),AtomTypesPair(2)),2)                    
                    call PotReadTableCommon(pottext, potFilename, bTable_text, eTable_text, r, U, PNPoints, PRMAX, PRMIN)                    
                    StateNB_iSjS(AtomTypesPair(2),AtomTypesPair(1))=StateNB_iSjS(AtomTypesPair(1),AtomTypesPair(2))
                    do iPoint=1, PNPoints
!                        iR=r(iPoint)*PNPoints/PRMAX+1.1
                        if (abs(r(iPoint)-(dfloat(iPoint)-0.5)*PRMAX/PNPoints).gt.PRMAX/PNPoints*0.4) then
                            write(stdout,*) 'ERROR: Reading Potentials:'
                            write(stdout,*) 'Suspicious spacing in NB-potential ',&
                                trim(AtomTypesPairStr(1)),'-',trim(AtomTypesPairStr(2)),&
                                ' check around point ',iPoint, 'of the potential'
                                stop                                
                        endif                        
!                        write(stdout,*) 'Debug: Read RDF: Detecting R,R: i=',iPoint,' iR=', iR
!                        GRDF(IndexGpotNB_riSjS(iR,rAtomTypesPair(1),AtomTypesPair(2)))=U(iPoint)
                        PotNB_riSjS(iPoint,AtomTypesPair(1),AtomTypesPair(2))=U(iPoint)                        
                        PotNB_riSjS(iPoint,AtomTypesPair(2),AtomTypesPair(1))=U(iPoint)                        
                    enddo    

                case ('B')
                    call PotReadPropB(pottext,potFilename, bPotential_text, ePotential_text, NameMType,MolType,iBond,NBondMType,&
                        AdrSiteMType,PRmin, PRmax, PNpoints,&
                        Bond_iSjS, NSiteGroupsInBond, i_SiteInBond, j_SiteInBond, k_SiteInBond, iprint, stdout)                    
                        ! State potential exists
                    StateB_iBond(iBond)=IBSet(StateB_iBond(iBond),3)                         
                    if (FlagFixed) StateB_iBond(iBond)=IBSet(StateB_iBond(iBond),2) ! State potential is fixed
                    NPointsPotB(iBond)=PNPoints
                    RMaxPotB(iBond)=PRmax
                    RMinPotB(iBond)=PRmin
                    call reshape2(PotB_riBond,PNPoints,NBonds)
                    call reshape2(rPotB_riBond,PNPoints,NBonds)

                    call PotReadTableCommon(pottext,PotFilename, bTable_text, eTable_text, r, U, PNPoints, PRMAX, PRMIN)
                    do iPoint=1, PNPoints
!                        iR=(r(iPoint)-PRMin)*PNPoints/(PRMax-PRMin)+1
                        rPotB_riBond(iPoint,iBond)=r(iPoint)
                         PotB_riBond(iPoint,iBond)=U(iPoint)
                        if (abs(r(iPoint)-PRMin-(iPoint-0.5)*(PRMax-PRMin)/PNPoints).gt.0.4*(PRMax-PRMin)/PNPoints) then
                            write(stdout,*) 'ERROR: Reading Potentials:'
                            write(stdout,*) 'Suspicious spacing in potential for Bond ',iBond-sum(NBondMType(1:MolType-1)),&
                                            ' check around line ',iPoint, 'of the potential'
                            write(stdout,*) 'Expected value: R(i)=',PRMin-(iPoint-0.5)*(PRMax-PRMin)/PNPoints,&
                                            'Actual read value R(i)=',r(iPoint) 
                                stop                                
                        endif                        
                    enddo                              
                case ('A')
                    call PotReadPropA(pottext,potFilename,bPotential_text,ePotential_text, NameMType, MolType,iBond, NBondMType,&
                        AdrSiteMType,PRmin, PRmax, PNpoints,&
                        Bond_iSjS, NSiteGroupsInBond, i_SiteInBond, j_SiteInBond, k_SiteInBond, iprint, stdout)
                    StateB_iBond(iBond)=IBSet(StateB_iBond(iBond),3)                         
                    if (FlagFixed) StateB_iBond(iBond)=IBSet(StateB_iBond(iBond),2) ! State potential is fixed
                    NPointsPotB(iBond)=PNPoints
                    RMaxPotB(iBond)=PRmax
                    RMinPotB(iBond)=PRmin
                    call reshape2(PotB_riBond,PNPoints,NBonds)
                    call reshape2(rPotB_riBond,PNPoints,NBonds)
                    call PotReadTableCommon(pottext,PotFilename, bTable_text, eTable_text, r, U, PNPoints, PRMAX, PRMIN)
                    do iPoint=1, PNPoints
!                        iR=(r(iPoint)-PRMin)*PNPoints/(PRMax-PRMin)+1
                        rPotB_riBond(iPoint,iBond)=r(iPoint)
                         PotB_riBond(iPoint,iBond)=U(iPoint)
                        if (abs(r(iPoint)-PRMin-(iPoint-0.5)*(PRMax-PRMin)/PNPoints).gt.0.4*(PRMax-PRMin)/PNPoints) then
                            write(stdout,*) 'ERROR: Reading Potentials:'
                            write(stdout,*) 'Suspicious spacing in potential for Bond ',iBond-sum(NBondMType(1:MolType-1)),&
                                            ' check around line ',iPoint, 'of the potential'
                            write(stdout,*) 'Expected value: R(i)=',PRMin-(iPoint-0.5)*(PRMax-PRMin)/PNPoints,&
                                            'Actual read value R(i)=',r(iPoint) 
                                stop                                
                        endif                        
                    enddo                              

            end select 
              
            write(stdout,*) 'Debug: Name:', trim(PNAME),', MIN:',PRMIN,', MAX:', PRMAX, ', NPoints:', PNPoints,&
            ', AtomTypes:', AtomTypesPair(1),'-',AtomTypesPair(2)          
            if (FlagFixed) write(stdout,*) 'Debug: Potential is FIXED' 
            if (FlagZero) write(stdout,*) 'Debug: Potential is ZERO' 
            
            ! Check if a potential-table of included-potential is found
            ! Read the table with potential points            
            if (FlagTableFound) call PotReadTableCommon(text,potFileName, bTable, eTable, r, U, PNPoints, PRMAX, PRMIN)            
            
!            if (FlagIncludeFileFound) call PotReadIncludedPotential(potFileName, r, U, PNPoints, PRMAX, PRMIN, PNAME,PType)
        endif        
        i=i+1
    enddo ! Loop over all the potentials    
    ! Indicate presence of &EndPotential and check consistency
    if (bPotential.eq.0) then
        write(stdout,*) 'ERROR: Reading Potential: Can not find section &Potential'
        stop
    endif
    if (ePotential.eq.0) then
        write(stdout,*) 'ERROR: Reading Potential: Can not find end of section &EndPotential'
        stop 
    endif
    ! TODO Check whether number of stated and read potentials are in agreement
    if (cnt_N_NB.ne.N_NB) then
        write(stdout,*) 'ERROR: Reading Potential: Number of actually read intermolecular (NB) potentials:',cnt_N_NB, &
                ' differs from the announced number of intermolecular (NB) potentials:',N_NB
        stop
    endif
    if (cnt_N_B.ne.N_B) then
        write(stdout,*) 'ERROR: Reading Potential: Number of actually read intramolecular bonded potentials:',cnt_N_B, &
                ' differs from the announced number of intramolecular bonded potentials:',N_B
        stop
    endif
    if (cnt_N_A.ne.N_A) then
        write(stdout,*) 'ERROR: Reading Potential: Number of actually read intramolecular angle bending potentials:',cnt_N_A, &
                ' differs from the announced number of intramolecular angle-bending potentials:',N_A
        stop
    endif
end subroutine
