subroutine WritePot(oFilename,N_NB, NBond, N_B, N_A, NPoints,RMax, RMin, NSType, NameSType, NameMType,&
    StateNB_iSjS, PotNB_riSjS, &
    MTypeBond, BTypeBond, NBondMType, AdrSiteMType,&
    NPointsPotB, RMaxPotB, RMinPotB, StateB_iBond, PotB_riBond,&! rPotB_riBond, &
    NSiteGroupsInBond, i_SiteInBond, j_SiteInBond, k_SiteInBond,&
    FKJM, irep)
    ! Global variables
    character(filename_text) oFilename
    integer N_NB, N_B, N_A, NPoints, NBond, irep
    real(8) RMax, RMin, FKJM
    integer NSType
    character(atom_name_len), allocatable:: NameSType(:) 
    character(filename_text) NameMType(:)    
    integer, allocatable:: StateNB_iSjS(:,:), StateB_iBond(:), NBondMType(:), BTypeBond(:), MTypeBond(:), NPointsPotB(:),&
        AdrSiteMType(:)
    integer, allocatable :: NSiteGroupsInBond(:), i_SiteInBond(:,:), j_SiteInBond(:,:), k_SiteInBond(:,:)
    real(8), allocatable:: RMaxPotB(:),RMinPotB(:)
    real(8), allocatable:: PotNB_riSjS(:,:,:), PotB_riBond(:,:), rPotB_riBond(:,:)
    ! Local variables
    integer iSType, jSType, iBond, lBond, iostt,i, iGroup, iMType
    character(filename_text) outFilename
       ! Opening file
    OutFileName=oFileName
    OutFileName(Len_Trim(OutFileName)+1:Len_Trim(OutFileName)+2)='.i'
    write(OutFileName(Len_Trim(OutFileName)+1:Len_Trim(OutFileName)+3),'(i0.3)') IREP
    OutFileName(Len_Trim(OutFileName)+1:Len_Trim(OutFileName)+4)='.pot'

    ! Write General section    
    open(unit=44,file=trim(outFilename),status='unknown',iostat=iostt)
    write(44,*) '&General'
    write(44,*) 'NTypes=',NSType
!    write(44,*) 'Types=', (trim(NameSType(iSType))//', ', iSType=1,size(NameSType))
    write(44,*) 'N_NB=',N_NB
    write(44,*) 'N_B=',N_B
    write(44,*) 'N_A=',N_A
    write(44,*) 'Min=',RMin
    write(44,*) 'Max=',RMax
    write(44,*) 'NPoints=',NPoints
    write(44,*) '&EndGeneral'    

    ! Write intermolecular (NB) potentials
    do iSType=1, NSType ! Loop over all posiible pairs of Site Types
        do jSType=iSType, NSType
            if (BTest(StateNB_iSjS(iSType,jSType),3)) then ! Potential exists            
                write(44,*) '&Potential'
                write(44,*) 'Name=',trim(NameSType(iSType)),'-',trim(NameSType(jSType))
                write(44,*) 'Type=NB'
                write(44,*) 'Min=',RMin
                write(44,*) 'Max=',RMax
                write(44,*) 'NPoints=',NPoints
                write(44,*) 'AtomTypes=',trim(NameSType(iSType)),',',trim(NameSType(jSType))
                if (BTest(StateNB_iSjS(iSType,jSType),2)) write(44,*) '&FIXED'
                ! Write a table
                write(44,*) '&Table'
                do i=1, size(PotNB_riSjS,1)
                    write(44,'(f14.7, f14.7)') RMin+(RMax-RMin)*(i-0.5)/NPoints, PotNB_riSjS(i,iSType,jSType)*FKJM
                enddo
                write(44,*) '&EndTable'
                
                write(44,*) '&EndPotential'
            endif
        enddo
    enddo
    ! Write Intramolecular (Bond) potentials
    do iBond=1, NBond ! Over all bonds in the system
        iMType=MTypeBond(iBond)
        if (BTest(StateB_iBond(iBond),3)) then ! If potential is defined            
            write(44,*) '&Potential'
            lBond=iBond-sum(NBondMType(1:iMType-1)) ! local number of the bond in the respective Molecular Type
            write(44,*) 'Name=',trim(NameMType(iMType)),':Bond ',lBond                
            if (BTypeBond(iBond).eq.1) then
                write(44,*) 'Type=B'
            elseif (BTypeBond(iBond).eq.2) then
                write(44,*) 'Type=A'
            endif
            
            write(44,*) 'MolType=',trim(NameMType(iMType))
            write(44,*) 'BondNumber=',lBond                                
            write(44,*) 'Min=',RMinPotB(iBond)
            write(44,*) 'Max=',RMaxPotB(iBond)
            write(44,*) 'NPoints=',NPointsPotB(iBond)
            if (BTest(StateB_iBond(iBond),2)) write(44,*) '&FIXED'
            ! Write NPairs/NTriplets and Pairs/Triplets
            if (BTypeBond(iBond).eq.1) then ! Pairwise Bond
                write(44,*) 'NPairs=',NSiteGroupsInBond(iBond)
                write(44,"(a6, i4, a1, i4)",advance='no') 'Pairs=',&
                   i_SiteInBond(iBond,1)-AdrSiteMType(iMType),'-',&
                   j_SiteInBond(iBond,1)-AdrSiteMType(iMType)
                do iGroup=2, NSiteGroupsInBond(iBond)
                    write(44,"(a2,i4,a1,i4)", advance='no') &
                    ', ',i_SiteInBond(iBond,iGroup)-AdrSiteMType(iMType),'-',&
                         j_SiteInBond(iBond,iGroup)-AdrSiteMType(iMType)
                enddo
                write(44,*) ''           !Endline          
            elseif (BTypeBond(iBond).eq.2) then ! Angle bending bond
                write(44,*) 'NTriplets=',NSiteGroupsInBond(iBond)
                write(44,"(a9,i4,a1,i4,a1,i4)",advance='no') 'Triplets=',&
                   i_SiteInBond(iBond,1)-AdrSiteMType(iMType),'-',&
                   k_SiteInBond(iBond,1)-AdrSiteMType(iMType),'-',&
                   j_SiteInBond(iBond,1)-AdrSiteMType(iMType)
                do iGroup=2, NSiteGroupsInBond(iBond)
                    write(44,"(a2,i4,a1,i4,a1,i4)", advance='no') &
                           ', ',i_SiteInBond(iBond,iGroup)-AdrSiteMType(iMType),'-',&
                                k_SiteInBond(iBond,iGroup)-AdrSiteMType(iMType),'-',&
                                j_SiteInBond(iBond,iGroup)-AdrSiteMType(iMType)
                enddo
                write(44,*) '' ! Endline
            endif
           ! Write a table
            write(44,*) '&Table'
            do i=1, NPointsPotB(iBond)
                write(44,'(f14.7, f14.7)') RMinPotB(iBond)+(RMaxPotB(iBond)-RMinPotB(iBond))*(i-0.5)/NPointsPotB(iBond),&
                    PotB_riBond(i,iBond)*FKJM
            enddo
            write(44,*) '&EndTable'
            write(44,*) '&EndPotential'
        endif
    enddo    
    ! Close file    
    close(44)
end subroutine 