! Subroutine reading potential from a file/set of files 
! The potential files have new syntax - version 2
! File:   readpot.f
! Author: Alexander Mirzoev
!
! Created on December 10, 2013, 12:48 PM
!


program testreadpot

    use strings
    use precision
    use mcmio
    use rdfio
    use potio
    implicit none
       
    !integer  stdout, iPrint, NMType
    integer, allocatable:: NSiteMType(:),NBondMType(:)
    character(filename_text) NameMType(2)
    real(8), allocatable :: SumMassMType(:)

    integer NSite, NSType
    integer, allocatable:: IndexSTypeSite(:),MTypeSite(:), MTypeSType(:), NSiteSType(:)
    character(atom_name_len), allocatable:: NameSite(:), NameSTypeSite(:), NameSType(:)
    integer, allocatable:: Bond_iSjS(:,:), i_SiteInBond(:,:), j_SiteInBond(:,:), k_SiteInBond(:,:), NSiteGroupsInBond(:),&
    NPairsTotalBond(:), BTypeBond(:),MTypeBond(:)
    integer NBond,NBondB, NBondA, NActNB
    real(8), allocatable:: RSite(:,:)                       
    real(8), allocatable:: MassSite(:), ChargeSite(:)    
    character*1024 ifile
    integer :: stdout=6, iPrint=15, NMType=3
    logical LMOVE(3)
!---------------------------------------------------------------------------------    
    logical ::LRDF=.True., LPOT=.True.    
    character(filename_text) FilRDF, FilPot
    integer :: NA=200
    real(8) :: POTCUT=1000., FRT=1.0
!---SetReferences--------------------------------------------------------------
    integer NMol, NMolMType(2), NAtom, NAtomChrgatom, NPointsNBGpot
    integer, allocatable :: AdrAtomMol(:), AdrMolMType(:), AdrSiteMType(:), AdrAtomMType(:),AdrBondMType(:), &
    MTypeMol(:), &
    MTypeAtom(:), MolAtom(:), STypeAtom(:), SiteAtom(:), &
    AtomChrgatom(:), &
    indexGPotNB_riSjS(:,:,:), IND(:,:,:), INDI(:,:), &
    StateNB_iSjS(:,:), StateB_iBond(:), &
    NPointsRDFB(:),NPointsPotB(:),&
    iRGPot(:), iSTypeNBGpot(:), jSTypeNBGpot(:)
    real(8), allocatable :: XCOMMol(:), YCOMMol(:), ZCOMMol(:), ChargeAtom(:)
    
!---ReadRDF---------------------------------------------------------
    real(8), allocatable::RDFref_NB_riSjS(:,:,:), RDFref_B_riBond(:,:), rRDFB_riBond(:,:)!,RDFA_iBond(:)    
    real(8), allocatable::PotNB_riSjS(:,:,:), PotB_riBond(:,:), rPotB_riBond(:,:)!,RDFA_iBond(:)
    real(8), allocatable::RMaxRDFB(:),RMinRDFB(:),RMaxPotB(:),RMinPotB(:)
    integer NPointsRDFNB, NPointsPotNB
    real(8) RMaxRDFNB, RMinRDFNB, RMaxPotNB, RMinPotNB
    
    character(filename_text) oFilename    
        
    NMolMType(1:2)=1
!    NMolMType(3)=126
    LMOVE(:)=.True.
    NameMType(1)='MT1'
    NameMType(2)='MT2'
    NMType=2
!    NameMType(3)='Na+.CG'
    FilRDF='test1.new.rdf'
    FilPot='test1.i000.new.pot'
    allocate(NSiteMType(NMType),NBondMType(NMType),SumMassMType(NMType))    

    call ReadMCM(NMType, NameMType, stdout, iPrint, &
    NSiteMType, NBondMType, SumMassMType,&
    NSite, NameSite, IndexSTypeSite, MTypeSite, RSite, MassSite,ChargeSite,  &
    NSType,MTypeSType, NSiteSType, NameSType,&    
    NBond, NBondB, NBondA, Bond_iSjS, i_SiteInBond, j_SiteInBond, k_SiteInBond, NSiteGroupsInBond,BTypeBond,MTypeBond)
    
    call SetReferences(NA, NMType, NMolMType, NSiteMType, NBondMType, &
    NMol, MTypeMol, XCOMMol, YCOMMol, ZCOMMol, &
    NSType, NSite, MTypeSite, IndexSTypeSite, ChargeSite, &
    NAtom, MTypeAtom, MolAtom, STypeAtom, SiteAtom, ChargeAtom, &
    NAtomChrgatom, AtomChrgatom, MTypeSType,&
    AdrAtomMol, AdrMolMType, AdrSiteMType, AdrAtomMType, AdrBondMType,&
    NBond, StateNB_iSjS, StateB_iBond,  NPairsTotalBond, NSiteGroupsInBond, &
    NPointsNBGpot, iRGPot,iSTypeNBGpot, jSTypeNBGpot, &
    indexGPotNB_riSjS, IND, &
    RDFref_NB_riSjS, PotNB_riSjS,& !RDFB_iBond,RDFA_iBond, 
    NPointsRDFB, RMaxRDFB, RMinRDFB, &
    NPointsPotB, RMaxPotB, RMinPotB, &
    LMOVE, &
    stdout, iPrint)
    
    if (LRDF) then 
                
        call ReadRDF(FilRDF, NameMType, NBondMType, AdrSiteMType, NSType, NameSType, NA,&
            StateNB_iSjS, StateB_iBond, RDFref_B_riBond, rRDFB_riBond, RDFref_NB_riSjS, Bond_iSjS, & 
            NSiteGroupsInBond, i_SiteInBond, j_SiteInBond, k_SiteInBond,&
            NPointsRDFNB, RMaxRDFNB, RMinRDFNB,&
            NPointsRDFB, RMaxRDFB, RMinRDFB, &
            IPrint, stdout)
    endif       

    if (LPOT) then
       
        call ReadPot(FilPot, NameMType, NBondMType,AdrSiteMType, NameSType, NA,&
        StateNB_iSjS,StateB_iBond, PotB_riBond, rPotB_riBond,PotNB_riSjS, Bond_iSjS, & 
        NSiteGroupsInBond, i_SiteInBond, j_SiteInBond, k_SiteInBond,&
        NPointsPotNB, RMaxPotNB, RMinPotNB,&
        NPointsPotB,RMaxPotB,RMinPotB, &
        IPrint, stdout) 
    endif
    
    call Initiate(NSType, NactNB, NBond, NBondB, NBondA, BTypeBond,MTypeBond, NameMType, NA, POTCUT,FRT, &
        NameSType, &
        StateNB_iSjS,StateB_iBond,&
        RDFref_NB_riSjS,PotNB_RiSjS,RDFref_B_riBond, PotB_riBond,rPotB_riBond,&    
        IND, INDI, &
        NPointsRDFNB,NPointsPotNB, RMaxRDFNB, RMaxPotNB, RMinRDFNB, RMinPotNB,&
        NPointsRDFB,NPointsPotB,RMaxRDFB,RMaxPotB,RMinRDFB,RMinPotB,&
        IPrint, stdout)
    
    ofilename='test1.output.pot'
    call WritePot(ofilename, NactNB, NBond, NBondB, NBondA, NPointsPotNB, RMaxPotNB, RMinPotNB, &
        NSType, NameSType, NameMType,&
        StateNB_iSjS, PotNB_riSjS, &
        MTypeBond, BTypeBond, NBondMType,&
        NPointsPotB, RMaxPotB, RMinPotB, StateB_iBond, PotB_riBond, rPotB_riBond, &
        NSiteGroupsInBond, i_SiteInBond, j_SiteInBond, k_SiteInBond)
    end
